subroutine SolveActiveLife(ik)
    !This subroutine computes optimal policies durin active worklife.
    use Model_Parameters
    use PolicyFunctions
    use glob0
    use Utilities
    !USE LCONF_INT
    !USE CSVAL_INT
    !USE NEQNF_INT
    !USE ERSET_INT

    implicit none

    integer, INTENT(IN) :: ik
    integer :: ix,ixd,iam,ium,iaf,iuf,iu2,iu3,tprint,ikd,j,ifc
    real(8), dimension (:,:,:,:,:,:,:), allocatable :: ce,cu,ke,ku,nem,nef,num,nuf,ve,vu
    real(8), dimension (:,:,:,:,:,:), allocatable :: ces,cus,kes,kus,nes,nus,ves,vus
    real(8), dimension (:), allocatable :: Expdum
    real(8), dimension (:,:,:), allocatable :: labormdum, laborfdum
    real(8), dimension (:,:), allocatable :: labor1workdum
    integer :: NEQ=0, IERSVR=0, IPACT=0, ISACT=0
    real(8) :: c2, MU2, d1, d2, vp(nu),dum3,dum4,dum5,dum6,y
    real(8) :: ACC=0.0001d0,ERREL=0.0001d0
    real(8) :: P1,P2,P3,P4,V2,V3,dum2,pnt2(3),pnt1(2)
    real(8) :: vnext


    allocate(ce(nk,T-it,na,nu,na,nu,nfc))
    allocate(cu(nk,T-it,na,nu,na,nu,nfc))
    allocate(ke(nk,T-it,na,nu,na,nu,nfc))
    allocate(ku(nk,T-it,na,nu,na,nu,nfc))
    allocate(nem(nk,T-it,na,nu,na,nu,nfc))
    allocate(nef(nk,T-it,na,nu,na,nu,nfc))
    allocate(num(nk,T-it,na,nu,na,nu,nfc))
    allocate(nuf(nk,T-it,na,nu,na,nu,nfc))
    allocate(ve(nk,T-it,na,nu,na,nu,nfc))
    allocate(vu(nk,T-it,na,nu,na,nu,nfc))
    allocate(labormdum(nc,nw,nw))
    allocate(laborfdum(nc,nw,nw))
    allocate(labor1workdum(nc,nw))

    ce=0d0
    cu=0d0
    ke=0d0
    ku=0d0
    nem=0d0
    nef=0d0
    num=0d0
    nuf=0d0
    ve=0d0
    vu=0d0

    allocate(ces(2,nk,T,na,nu,nfc))
    allocate(cus(2,nk,T,na,nu,nfc))
    allocate(kes(2,nk,T,na,nu,nfc))
    allocate(kus(2,nk,T,na,nu,nfc))
    allocate(nes(2,nk,T,na,nu,nfc))
    allocate(nus(2,nk,T,na,nu,nfc))
    allocate(ves(2,nk,T,na,nu,nfc))
    allocate(vus(2,nk,T,na,nu,nfc))

    ces=0d0
    cus=0d0
    kes=0d0
    kus=0d0
    nes=0d0
    nus=0d0
    ves=0d0
    vus=0d0

    !if both spouses employed

        labormdum=laborm(:,:,:)
        laborfdum=laborf(:,:,:)
        do ifc=1,nfc
        do iam = 1, na
            do ium = 1, nu
                do iaf = 1, na
                    do iuf = 1, nu
                        do ix = 1, T-it
                            !Finding optimal capital by golden search
                            wagem = wage(1,a(1,iam),dble(T-it),u(1,ium))/(1d0+t_employer)
                            wagef = wage(2,a(2,iaf),dble(ix),u(2,iuf))/(1d0+t_employer)
                            P1=0.01d0
                            P4=min((k_grid(nk)-0.001d0)/(1d0+tc),((k_grid(ik) + Gamma_redistr)*(1d0+r*(1d0-tk))+lumpsum+(wagem+wagef)*(1d0-tax_labor(wagem+wagef)-tSS_employee(wagem+wagef)))/(1d0+tc))
                            do
                                P2 = P1 + ((3.0-sqrt(5.0))/2.0)*(P4-P1)
                                P3 = P1 + ((sqrt(5.0)-1.0)/2.0)*(P4-P1)

                                pnt2 = (/P2, wagem, wagef/)
                                dum4 = min(max(trilin_interp(c_grid, wage_grid, wage_grid, labormdum, nc, nw, nw, pnt2),1d-10),1d0)
                                dum5 = min(max(trilin_interp(c_grid, wage_grid, wage_grid, laborfdum, nc, nw, nw, pnt2),1d-10),1d0)
                                y=dum4*wagem+dum5*wagef
                                dum2=((k_grid(ik) + Gamma_redistr)*(1d0+r*(1d0-tk))+lumpsum+y*(1d0-tax_labor(y)-tSS_employee(y))-P2*(1d0+tc))/(1d0+mu)
                                if(dum2<0d0) then
                                    V2=-999999999d0
                                else
                                    V2=Uc(P2)+Ul(dum4,dum5)-fc(1,ifc)
                                    !V2=V2+beta*OmegaActive(T-it)*D_CSVAL(dum2,BREAK,ev_spln_coefs(:,:,ix+1,iam,ium,iaf,iuf,T+1-it,j,ifc))

                                    vnext = ppp_csval(dum2, k_grid, nk, ev_spln_coefs(:,:,ix+1,iam,ium,iaf,iuf,T+1-it,ifc))
                                    V2=V2+beta*OmegaActive(T-it)*vnext

                                    !V2=V2+beta*OmegaActive(T-it)*(1d0-Probd(T-it))*D_CSVAL(dum2,BREAK,ev_spln_coefs(:,:,ix+1,iam,ium,iaf,iuf,T+1-it,j,ifc))
                                    !V2=V2+beta*OmegaActive(T-it)*Probd(T-it)*0.5d0*D_CSVAL(dum2/2d0,BREAK,evs_spln_coefs(1,:,:,1,iam,ium,T+1-it,ifc))
                                    !V2=V2+beta*OmegaActive(T-it)*Probd(T-it)*0.5d0*D_CSVAL(dum2/2d0,BREAK,evs_spln_coefs(2,:,:,ix+1,iaf,iuf,T+1-it,ifc))
                                end if

                                pnt2 = (/P3, wagem, wagef/)
                                dum4 = min(max(trilin_interp(c_grid, wage_grid, wage_grid, labormdum, nc, nw, nw, pnt2),1d-10),1d0)
                                dum5 = min(max(trilin_interp(c_grid, wage_grid, wage_grid, laborfdum, nc, nw, nw, pnt2),1d-10),1d0)
                                y=dum4*wagem+dum5*wagef
                                dum2=((k_grid(ik) + Gamma_redistr)*(1d0+r*(1d0-tk))+lumpsum+y*(1d0-tax_labor(y)-tSS_employee(y))-P3*(1d0+tc))/(1d0+mu)
                                if(dum2<0d0) then
                                    V3=-999999999d0
                                else
                                    V3=Uc(P3)+Ul(dum4,dum5)-fc(1,ifc)
                                    !V3=V3+beta*OmegaActive(T-it)*D_CSVAL(dum2,BREAK,ev_spln_coefs(:,:,ix+1,iam,ium,iaf,iuf,T+1-it,j,ifc))

                                    vnext = ppp_csval(dum2, k_grid, nk, ev_spln_coefs(:,:,ix+1,iam,ium,iaf,iuf,T+1-it,ifc))
                                    V3=V3+beta*OmegaActive(T-it)*vnext
                                    !V3=V3+beta*OmegaActive(T-it)*(1d0-Probd(T-it))*D_CSVAL(dum2,BREAK,ev_spln_coefs(:,:,ix+1,iam,ium,iaf,iuf,T+1-it,j,ifc))
                                    !V3=V3+beta*OmegaActive(T-it)*Probd(T-it)*0.5d0*D_CSVAL(dum2/2d0,BREAK,evs_spln_coefs(1,:,:,1,iam,ium,T+1-it,ifc))
                                    !V3=V3+beta*OmegaActive(T-it)*Probd(T-it)*0.5d0*D_CSVAL(dum2/2d0,BREAK,evs_spln_coefs(2,:,:,ix+1,iaf,iuf,T+1-it,ifc))
                                end if

                                if (V2 < V3) then
                                    P1=P2
                                else
                                    P4=P3
                                end if
                                if((P4-P1)<1d-4) exit
                            end do

                            Ve(ik,ix,iam,ium,iaf,iuf,ifc)=V2
                            ke(ik,ix,iam,ium,iaf,iuf,ifc)=dum2
                            nem(ik,ix,iam,ium,iaf,iuf,ifc)=dum4
                            nef(ik,ix,iam,ium,iaf,iuf,ifc)=dum5
                            ce(ik,ix,iam,ium,iaf,iuf,ifc)=P2
                            if(dum4<0d0) then
                                pause
                            end if
                            if(dum5<0d0) then
                                pause
                            end if
                        end do
                    end do
                end do
            end do
        end do
        end do

    !If female unemployed

        labor1workdum=labor1work(:,:)
        do ifc=1,nfc
        do iam = 1, na
            do ium = 1, nu
                do iaf = 1, na
                    do iuf = 1, nu
                        do ix = 1, T-it
                            !Finding optimal capital by golden search
                            wagem = wage(1,a(1,iam),dble(T-it),u(1,ium))/(1d0+t_employer)
                            P1=0.01d0
                            P4=min((k_grid(nk)-0.001d0)/(1d0+tc),((k_grid(ik) + Gamma_redistr)*(1d0+r*(1d0-tk))+lumpsum+Unemp_benefit+(wagem)*(1d0-tax_labor(wagem)-tSS_employee(wagem)))/(1d0+tc))
                            do
                                P2 = P1 + ((3.0-sqrt(5.0))/2.0)*(P4-P1)
                                P3 = P1 + ((sqrt(5.0)-1.0)/2.0)*(P4-P1)

                                pnt1 = (/P2, wagem/)
                                dum4 = min(max(bilin_interp(c_grid, wage_grid, labor1workdum, nc, nw, pnt1),0d0),1d0)
                                y=dum4*wagem
                                dum2=((k_grid(ik) + Gamma_redistr)*(1d0+r*(1d0-tk))+lumpsum+Unemp_benefit+y*(1d0-tax_labor(y)-tSS_employee(y))-P2*(1d0+tc))/(1d0+mu)
                                if(dum2<0d0) then
                                    V2=-999999999d0
                                else
                                    V2=Uc(P2)+Ul(dum4,0d0)
                                    !V2=V2+beta*OmegaActive(T-it)*D_CSVAL(dum2,BREAK,ev_spln_coefs(:,:,ix,iam,ium,iaf,iuf,T+1-it,j,ifc))
                                    vnext = ppp_csval(dum2, k_grid, nk, ev_spln_coefs(:,:,ix,iam,ium,iaf,iuf,T+1-it,ifc))
                                    V2=V2+beta*OmegaActive(T-it)*vnext
                                    !V2=V2+beta*OmegaActive(T-it)*(1d0-Probd(T-it))*D_CSVAL(dum2,BREAK,ev_spln_coefs(:,:,ix,iam,ium,iaf,iuf,T+1-it,j,ifc))
                                    !V2=V2+beta*OmegaActive(T-it)*Probd(T-it)*0.5d0*D_CSVAL(dum2/2d0,BREAK,evs_spln_coefs(1,:,:,1,iam,ium,T+1-it,ifc))
                                    !V2=V2+beta*OmegaActive(T-it)*Probd(T-it)*0.5d0*D_CSVAL(dum2/2d0,BREAK,evs_spln_coefs(2,:,:,ix,iaf,iuf,T+1-it,ifc))
                                end if

                                pnt1 = (/P3, wagem/)
                                dum4 = min(max(bilin_interp(c_grid, wage_grid, labor1workdum, nc, nw, pnt1),0d0),1d0)
                                y=dum4*wagem
                                dum2=((k_grid(ik) + Gamma_redistr)*(1d0+r*(1d0-tk))+lumpsum+Unemp_benefit+y*(1d0-tax_labor(y)-tSS_employee(y))-P3*(1d0+tc))/(1d0+mu)
                                if(dum2<0d0) then
                                    V3=-999999999d0
                                else
                                    V3=Uc(P3)+Ul(dum4,0d0)
                                    !V3=V3+beta*OmegaActive(T-it)*D_CSVAL(dum2,BREAK,ev_spln_coefs(:,:,ix,iam,ium,iaf,iuf,T+1-it,j,ifc))

                                    vnext = ppp_csval(dum2, k_grid, nk, ev_spln_coefs(:,:,ix,iam,ium,iaf,iuf,T+1-it,ifc))
                                    V3=V3+beta*OmegaActive(T-it)*vnext
                                    !V3=V3+beta*OmegaActive(T-it)*(1d0-Probd(T-it))*D_CSVAL(dum2,BREAK,ev_spln_coefs(:,:,ix,iam,ium,iaf,iuf,T+1-it,j,ifc))
                                    !V3=V3+beta*OmegaActive(T-it)*Probd(T-it)*0.5d0*D_CSVAL(dum2/2d0,BREAK,evs_spln_coefs(1,:,:,1,iaf,iuf,T+1-it,ifc))
                                    !V3=V3+beta*OmegaActive(T-it)*Probd(T-it)*0.5d0*D_CSVAL(dum2/2d0,BREAK,evs_spln_coefs(2,:,:,ix,iaf,iuf,T+1-it,ifc))
                                end if

                                if (V2 < V3) then
                                    P1=P2
                                else
                                    P4=P3
                                end if
                                if((P4-P1)<1d-4) exit
                            end do

                            Vu(ik,ix,iam,ium,iaf,iuf,ifc)=V2
                            ku(ik,ix,iam,ium,iaf,iuf,ifc)=dum2
                            num(ik,ix,iam,ium,iaf,iuf,ifc)=dum4
                            nuf(ik,ix,iam,ium,iaf,iuf,ifc)=0d0
                            cu(ik,ix,iam,ium,iaf,iuf,ifc)=P2
                            if(dum4<0d0) then
                                pause
                            end if
                        end do
                    end do
                end do
            end do
        end do
        end do

    !Vu=-999999999d0

        do ifc=1,nfc
        do ium = 1, nu
            do ix = 1, T-it
                do iam = 1, na
                    do iuf = 1, nu
                        do iaf = 1, na
                            if (ve(ik,ix,iam,ium,iaf,iuf,ifc) >= vu(ik,ix,iam,ium,iaf,iuf,ifc)) then
                                v(ik,ix,iam,ium,iaf,iuf,T-it,ifc)=ve(ik,ix,iam,ium,iaf,iuf,ifc)
                                c(ik,ix,iam,ium,iaf,iuf,T-it,ifc)=ce(ik,ix,iam,ium,iaf,iuf,ifc)
                                k(ik,ix,iam,ium,iaf,iuf,T-it,ifc)=ke(ik,ix,iam,ium,iaf,iuf,ifc)
                                nm(ik,ix,iam,ium,iaf,iuf,T-it,ifc)=nem(ik,ix,iam,ium,iaf,iuf,ifc)
                                nf(ik,ix,iam,ium,iaf,iuf,T-it,ifc)=nef(ik,ix,iam,ium,iaf,iuf,ifc)
                            else
                                v(ik,ix,iam,ium,iaf,iuf,T-it,ifc)=vu(ik,ix,iam,ium,iaf,iuf,ifc)
                                c(ik,ix,iam,ium,iaf,iuf,T-it,ifc)=cu(ik,ix,iam,ium,iaf,iuf,ifc)
                                k(ik,ix,iam,ium,iaf,iuf,T-it,ifc)=ku(ik,ix,iam,ium,iaf,iuf,ifc)
                                nm(ik,ix,iam,ium,iaf,iuf,T-it,ifc)=num(ik,ix,iam,ium,iaf,iuf,ifc)
                                nf(ik,ix,iam,ium,iaf,iuf,T-it,ifc)=nuf(ik,ix,iam,ium,iaf,iuf,ifc)
                            end if
                        end do
                    end do
                end do
            end do
        end do
        end do


    !ev(ik,:,:,:,:,:,T-it,:)=0d0
    !do j=1, nfam
    !do ium = 1, nu
    !    do ix = 1, T-it
    !        do iam = 1, na
    !            do iuf = 1, nu
    !                do iaf = 1, na
    !                    do iu2=1,nu
    !                        do iu3=1,nu
    !                            ev(ik,ix,iam,ium,iaf,iuf,T-it,j,ifc)=ev(ik,ix,iam,ium,iaf,iuf,T-it,j,ifc)+trans_u(1,ium,iu2)*trans_u(2,iuf,iu3)*V(ik,ix,iam,iu2,iaf,iu3,T-it,j,ifc)
    !                        end do
    !                    end do
    !                end do
    !            end do
    !        end do
    !    end do
    !end do
    !end do

    !Singles

    j=2

    do ifc=1,nfc
    do iam = 1, na
        do ium = 1, nu
            do ix = 1, T-it
                !Print *,'ix is',ix
                !Finding optimal capital by golden search
                wagef = wage(2,a(2,iam),dble(ix),u(2,ium))/(1d0+t_employer)
                P1=0.01d0
                P4=min((k_grid(nk)-0.001d0)/(1d0+tc),((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+wagef*(1d0-tax_labors(wagef)-tSS_employee(wagef)))/(1d0+tc))
                do
                    P2 = P1 + ((3.0-sqrt(5.0))/2.0)*(P4-P1)
                    P3 = P1 + ((sqrt(5.0)-1.0)/2.0)*(P4-P1)

                    pnt1 = (/P2, wagef/)
                    dum4 = min(max(bilin_interp(c_grid, wage_grid, laborsinglef, nc, nw, pnt1),0d0),1d0)
                    y=dum4*wagef
                    dum2=((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+y*(1d0-tax_labors(y)-tSS_employee(y))-P2*(1d0+tc))/(1d0+mu)
                    if(dum2<0d0) then
                        V2=-999999999d0
                    else
                        V2=Uc(P2)-chifs*(dum4**(1d0+etaf))/(1d0+etaf)-fc(2,ifc)
                        !V2=V2+beta*OmegaActive(T-it)*(1d0-Probm(T-it))*D_CSVAL(dum2,BREAK,evs_spln_coefs(j,:,:,ix+1,iam,ium,T+1-it,ifc))

                        vnext = ppp_csval(dum2, k_grid, nk, evs_spln_coefs(j,:,:,ix+1,iam,ium,T+1-it,ifc))
                        V2=V2+beta*OmegaActive(T-it)*(1d0-Probm(T-it))*vnext

                        !V2=V2+beta*OmegaActive(T-it)*Probm(T-it)*D_CSVAL(dum2,BREAK,evm_spln_coefs(j,:,:,ix+1,iam,ium,T+1-it,ifc))
                        vnext = ppp_csval(dum2, k_grid, nk, evm_spln_coefs(j,:,:,ix+1,iam,ium,T+1-it,ifc))
                        V2=V2+beta*OmegaActive(T-it)*Probm(T-it)*vnext
                    end if

                    pnt1 = (/P3, wagef/)
                    dum4 = min(max(bilin_interp(c_grid, wage_grid, laborsinglef, nc, nw, pnt1),0d0),1d0)
                    y=dum4*wagef
                    dum2=((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+y*(1d0-tax_labors(y)-tSS_employee(y))-P3*(1d0+tc))/(1d0+mu)
                    if(dum2<0d0) then
                        V3=-999999999d0
                    else
                        V3=Uc(P3)-chifs*(dum4**(1d0+etaf))/(1d0+etaf)-fc(2,ifc)
                        !V3=V3+beta*OmegaActive(T-it)*(1d0-Probm(T-it))*D_CSVAL(dum2,BREAK,evs_spln_coefs(j,:,:,ix+1,iam,ium,T+1-it,ifc))

                        vnext = ppp_csval(dum2, k_grid, nk, evs_spln_coefs(j,:,:,ix+1,iam,ium,T+1-it,ifc))
                        V3=V3+beta*OmegaActive(T-it)*(1d0-Probm(T-it))*vnext

                        !V3=V3+beta*OmegaActive(T-it)*Probm(T-it)*D_CSVAL(dum2,BREAK,evm_spln_coefs(j,:,:,ix+1,iam,ium,T+1-it,ifc))
                        vnext = ppp_csval(dum2, k_grid, nk, evm_spln_coefs(j,:,:,ix+1,iam,ium,T+1-it,ifc))
                        V3=V3+beta*OmegaActive(T-it)*Probm(T-it)*vnext
                    end if

                    if (V2 < V3) then
                        P1=P2
                    else
                        P4=P3
                    end if
                    if((P4-P1)<1d-4) exit
                end do

                Ves(j,ik,ix,iam,ium,ifc)=V2
                kes(j,ik,ix,iam,ium,ifc)=dum2
                nes(j,ik,ix,iam,ium,ifc)=dum4
                ces(j,ik,ix,iam,ium,ifc)=P2

                if(nes(j,ik,ix,iam,ium,ifc)<0d0) then
                    Print *,'ik is',ik
                    Print *,'ix is',ix
                    Print *,'iam is',iam
                    Print *,'ium is',ium
                    Print *,'nes(j,ik,ix,iam,ium,ifc) is',nes(j,ik,ix,iam,ium,ifc)
                    pause
                end if
            end do
        end do
    end do
    end do

    !If female unemployed

    do ifc=1,nfc
    do iam = 1, na
        do ium = 1, nu
            do ix = 1, T-it
                !Print *,'ix is',ix
                !Finding optimal capital by golden search
                P1=0.01d0
                P4=min((k_grid(nk)-0.001d0)/(1d0+tc),((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+Unemp_benefit)/(1d0+tc))
                do
                    P2 = P1 + ((3.0-sqrt(5.0))/2.0)*(P4-P1)
                    P3 = P1 + ((sqrt(5.0)-1.0)/2.0)*(P4-P1)
                    dum2=((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+Unemp_benefit-P2*(1d0+tc))/(1d0+mu)
                    if(dum2<0d0) then
                        V2=-999999999d0
                    else
                        V2=Uc(P2)
                        !V2=V2+beta*OmegaActive(T-it)*(1d0-Probm(T-it))*D_CSVAL(dum2,BREAK,evs_spln_coefs(j,:,:,ix,iam,ium,T+1-it,ifc))

                        vnext = ppp_csval(dum2, k_grid, nk, evs_spln_coefs(j,:,:,ix,iam,ium,T+1-it,ifc))
                        V2=V2+beta*OmegaActive(T-it)*(1d0-Probm(T-it))*vnext

                        !V2=V2+beta*OmegaActive(T-it)*Probm(T-it)*D_CSVAL(dum2,BREAK,evm_spln_coefs(j,:,:,ix,iam,ium,T+1-it,ifc))
                        vnext = ppp_csval(dum2, k_grid, nk, evm_spln_coefs(j,:,:,ix,iam,ium,T+1-it,ifc))
                        V2=V2+beta*OmegaActive(T-it)*Probm(T-it)*vnext
                    end if

                    dum2=((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+Unemp_benefit-P3*(1d0+tc))/(1d0+mu)
                    if(dum2<0d0) then
                        V3=-999999999d0
                    else
                        V3=Uc(P3)
                        !V3=V3+beta*OmegaActive(T-it)*(1d0-Probm(T-it))*D_CSVAL(dum2,BREAK,evs_spln_coefs(j,:,:,ix,iam,ium,T+1-it,ifc))

                        vnext = ppp_csval(dum2, k_grid, nk, evs_spln_coefs(j,:,:,ix,iam,ium,T+1-it,ifc))
                        V3=V3+beta*OmegaActive(T-it)*(1d0-Probm(T-it))*vnext

                        !V3=V3+beta*OmegaActive(T-it)*Probm(T-it)*D_CSVAL(dum2,BREAK,evm_spln_coefs(j,:,:,ix,iam,ium,T+1-it,ifc))                      
                        vnext = ppp_csval(dum2, k_grid, nk, evm_spln_coefs(j,:,:,ix,iam,ium,T+1-it,ifc))
                        V3=V3+beta*OmegaActive(T-it)*Probm(T-it)*vnext                      
                    end if                    



                    if (V2 < V3) then
                        P1=P2
                    else
                        P4=P3
                    end if
                    if((P4-P1)<1d-4) exit
                end do

                Vus(j,ik,ix,iam,ium,ifc)=V2
                kus(j,ik,ix,iam,ium,ifc)=dum2
                nus(j,ik,ix,iam,ium,ifc)=0d0
                cus(j,ik,ix,iam,ium,ifc)=P2

            end do
        end do
    end do
    end do

    !Vus=-999999999d0
    
    do ifc=1,nfc
    do ium = 1, nu
        do ix = 1, T-it
            do iam = 1, na
                if (ves(j,ik,ix,iam,ium,ifc) >= vus(j,ik,ix,iam,ium,ifc)) then
                    vs(j,ik,ix,iam,ium,T-it,ifc)=ves(j,ik,ix,iam,ium,ifc)
                    cs(j,ik,ix,iam,ium,T-it,ifc)=ces(j,ik,ix,iam,ium,ifc)
                    ks(j,ik,ix,iam,ium,T-it,ifc)=kes(j,ik,ix,iam,ium,ifc)
                    ns(j,ik,ix,iam,ium,T-it,ifc)=nes(j,ik,ix,iam,ium,ifc)
                else
                    vs(j,ik,ix,iam,ium,T-it,ifc)=vus(j,ik,ix,iam,ium,ifc)
                    cs(j,ik,ix,iam,ium,T-it,ifc)=cus(j,ik,ix,iam,ium,ifc)
                    ks(j,ik,ix,iam,ium,T-it,ifc)=kus(j,ik,ix,iam,ium,ifc)
                    ns(j,ik,ix,iam,ium,T-it,ifc)=nus(j,ik,ix,iam,ium,ifc)
                end if
            end do
        end do
    end do
    end do


    !do ium = 1, nu
    !    do ixd = 1, ixm
    !        do iam = 1, na
    !                    ix=min((1+(ixd-1)*4),(T-it))
    !                    vsdum(j,ik,ixd,iam,ium,T-it,ifc)=vs(j,ik,ix,iam,ium,T-it,ifc)
    !                    csdum(j,ik,ixd,iam,ium,T-it,ifc)=cs(j,ik,ix,iam,ium,T-it,ifc)
    !                    gksdum(j,ik,ixd,iam,ium,T-it,ifc)=ks(j,ik,ix,iam,ium,T-it,ifc)
    !                    nsdum(j,ik,ixd,iam,ium,T-it,ifc)=ns(j,ik,ix,iam,ium,T-it,ifc)
    !        end do
    !    end do
    !end do

    !Print *,'nmdum(1,:,1,1,1,1,T) is',nmdum(1,:,1,1,1,1,T)

    !do ium = 1, nu
    !    do ix = 1, T-it
    !        do iam = 1, na
    !                    vs(j,ik,ix,iam,ium,T-it,ifc)=LinInterp(ix*1d0,Expdum,vsdum(j,ik,:,iam,ium,T-it,ifc),ixm)
    !                    cs(j,ik,ix,iam,ium,T-it,ifc)=LinInterp(ix*1d0,Expdum,csdum(j,ik,:,iam,ium,T-it,ifc),ixm)
    !                    ks(j,ik,ix,iam,ium,T-it,ifc)=LinInterp(ix*1d0,Expdum,gksdum(j,ik,:,iam,ium,T-it,ifc),ixm)
    !                    ns(j,ik,ix,iam,ium,T-it,ifc)=LinInterp(ix*1d0,Expdum,nsdum(j,ik,:,iam,ium,T-it,ifc),ixm)
    !                if(ns(j,ik,ix,iam,ium,T-it,ifc)<0d0) then
    !                print *, 'interpolation'
    !                Print *,'ik is',ik
    !                Print *,'ix is',ix
    !                Print *,'iam is',iam
    !                Print *,'ium is',ium
    !                Print *,'iaf is',iaf
    !                Print *,'iuf is',iuf
    !                Print *,'ns(j,ik,ix,iam,ium,T-it,ifc) is',ns(j,ik,ix,iam,ium,T-it,ifc)
    !                Print *,'Expdum is',Expdum
    !                Print *,'nsdum(j,ik,ixd,iam,ium,T-it,ifc) is',nsdum(j,ik,ixd,iam,ium,T-it,ifc)
    !                pause
    !                end if
    !        end do
    !    end do
    !end do

    !Men   
    j=1
    ifc=1
    
    do iam = 1, na
        do ium = 1, nu
            !Print *,'ix is',ix
            !Finding optimal capital by golden search
            wagem = wage(1,a(1,iam),dble(T-it),u(1,ium))/(1d0+t_employer)
            P1=0.01d0
            P4=min((k_grid(nk)-0.001d0)/(1d0+tc),((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+wagem*(1d0-tax_labors(wagem)-tSS_employee(wagem)))/(1d0+tc))
            do
                P2 = P1 + ((3.0-sqrt(5.0))/2.0)*(P4-P1)
                P3 = P1 + ((sqrt(5.0)-1.0)/2.0)*(P4-P1)

                pnt1 = (/P2, wagem/)
                dum4 = min(max(bilin_interp(c_grid, wage_grid, laborsinglem, nc, nw, pnt1),0d0),1d0)
                y=dum4*wagem
                dum2=((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+y*(1d0-tax_labors(y)-tSS_employee(y))-P2*(1d0+tc))/(1d0+mu)
                if(dum2<0d0) then
                    V2=-999999999d0
                else
                    V2=Uc(P2)-chims*(dum4**(1d0+etam))/(1d0+etam)
                    !V2=V2+beta*OmegaActive(T-it)*(1d0-Probm(T-it))*D_CSVAL(dum2,BREAK,evs_spln_coefs(j,:,:,1,iam,ium,T+1-it,ifc))

                    vnext = ppp_csval(dum2, k_grid, nk, evs_spln_coefs(j,:,:,1,iam,ium,T+1-it,ifc))
                    V2=V2+beta*OmegaActive(T-it)*(1d0-Probm(T-it))*vnext

                    !V2=V2+beta*OmegaActive(T-it)*Probm(T-it)*D_CSVAL(dum2,BREAK,evm_spln_coefs(j,:,:,1,iam,ium,T+1-it,ifc))
                    vnext = ppp_csval(dum2, k_grid, nk, evm_spln_coefs(j,:,:,1,iam,ium,T+1-it,ifc))
                    V2=V2+beta*OmegaActive(T-it)*Probm(T-it)*vnext
                end if

                pnt1 = (/P3, wagem/)
                dum4 = min(max(bilin_interp(c_grid, wage_grid, laborsinglem, nc, nw, pnt1),0d0),1d0)
                y=dum4*wagem
                dum2=((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+y*(1d0-tax_labors(y)-tSS_employee(y))-P3*(1d0+tc))/(1d0+mu)
                if(dum2<0d0) then
                    V3=-999999999d0
                else
                    V3=Uc(P3)-chims*(dum4**(1d0+etam))/(1d0+etam)
                    !V3=V3+beta*OmegaActive(T-it)*(1d0-Probm(T-it))*D_CSVAL(dum2,BREAK,evs_spln_coefs(j,:,:,1,iam,ium,T+1-it,ifc))

                    vnext = ppp_csval(dum2, k_grid, nk, evs_spln_coefs(j,:,:,1,iam,ium,T+1-it,ifc))
                    V3=V3+beta*OmegaActive(T-it)*(1d0-Probm(T-it))*vnext

                    !V3=V3+beta*OmegaActive(T-it)*Probm(T-it)*D_CSVAL(dum2,BREAK,evm_spln_coefs(j,:,:,1,iam,ium,T+1-it,ifc))
                    vnext = ppp_csval(dum2, k_grid, nk, evm_spln_coefs(j,:,:,1,iam,ium,T+1-it,ifc))
                    V3=V3+beta*OmegaActive(T-it)*Probm(T-it)*vnext
                end if

                if (V2 < V3) then
                    P1=P2
                else
                    P4=P3
                end if
                if((P4-P1)<1d-4) exit
            end do

            Vs(j,ik,:,iam,ium,T-it,:)=V2
            ks(j,ik,:,iam,ium,T-it,:)=dum2
            ns(j,ik,:,iam,ium,T-it,:)=dum4
            cs(j,ik,:,iam,ium,T-it,:)=P2

            if(ns(j,ik,1,iam,ium,T,1)<0d0) then
                Print *,'ik is',ik
                Print *,'iam is',iam
                Print *,'ium is',ium
                Print *,'ns(j,ik,1,iam,ium,T,1) is',ns(j,ik,1,iam,ium,T-it,1)
                pause
            end if
        end do
    end do


    evs(:,ik,:,:,:,T-it,:)=0d0

    j=2
    
    do ium = 1, nu
        do ifc=1,nfc
            do ix = 1, T-it
                do iam = 1, na
                    do iu2=1,nu
                        evs(j,ik,ix,iam,ium,T-it,ifc)=evs(j,ik,ix,iam,ium,T-it,ifc)+trans_u(2,ium,iu2)*Vs(j,ik,ix,iam,iu2,T-it,ifc)
                    end do
                end do
            end do
        end do
    end do

    j=1
    do ium = 1, nu
        do iam = 1, na
            do iu2=1,nu    
                evs(j,ik,:,iam,ium,T-it,:)=evs(j,ik,:,iam,ium,T-it,:)+trans_u(1,ium,iu2)*Vs(j,ik,1,iam,iu2,T-it,1)
            end do
        end do
    end do

end subroutine SolveActiveLife
