module PolicyFunctions
    
        use Model_Parameters
        
        implicit none
        ! Policy functions for active period of life
        
        real(8), dimension (:,:,:,:), allocatable :: v,vdum,ev  !Value function and expected value function
        real(8), dimension (:,:,:,:), allocatable :: c,cdum   !Consumption
        real(8), dimension (:,:,:,:), allocatable :: k,gkdum  !Capital
        real(8), dimension (:,:,:,:), allocatable :: n,ndum   !Labor supply
        real(8), dimension (:,:,:,:,:), allocatable :: ev_spln_coefs, v_spln_coefs
        
        real(8), dimension (:), allocatable :: c_grid
        real(8), dimension (:), allocatable :: wage_grid
        real(8), dimension (:), allocatable :: k_grid
        real(8), dimension (:,:), allocatable :: labor
       
        ! Policy functions for retired
        real(8), dimension (:,:,:), allocatable :: ev_spln_coefs_ret
        real(8), dimension (:,:), allocatable :: v_ret
        real(8), dimension (:,:), allocatable :: c_ret
        real(8), dimension (:,:), allocatable :: k_ret
        real(8), dimension (:), allocatable :: break
        
    end module PolicyFunctions