subroutine simulation(ik)
!This subroutine simulates the lifecycle for nsim households
use Model_Parameters
use PolicyFunctions
use Utilities

implicit none

integer, INTENT(IN) :: ik
integer :: i,ia,iu,it2,it3,it4,it5,j,count2,j2
real(8) :: dum2,dum3,dum4,dum5,dum6

dum2=0.0


!This vectors will hold various statistics

Sim1(ik,:,:,:)=0d0

!Assigning the asset level for 20-year olds

Sim1(ik,:,1,1)=0.440852*AE

!This vector will hold, ability and the idiosyncratic shock

exp1(ik,:,:,1)=0

!Initialzing the idiosyncratic shocks to wages

do it2=1,nsim
    if(Random1(ik,it2)<Prob_u(1)) then
        exp1(ik,it2,1,3)=1
    elseif((Prob_u(1)<Random1(ik,it2)).AND.(Random1(ik,it2)<(Prob_u(1)+Prob_u(2)))) then
        exp1(ik,it2,1,3)=2
    elseif(((Prob_u(1)+Prob_u(2))<Random1(ik,it2)).AND.(Random1(ik,it2)<(Prob_u(1)+Prob_u(2)+Prob_u(3)))) then
        exp1(ik,it2,1,3)=3
    elseif(((Prob_u(1)+Prob_u(2)+Prob_u(3))<Random1(ik,it2)).AND.(Random1(ik,it2)<(Prob_u(1)+Prob_u(2)+Prob_u(3)+Prob_u(4)))) then
        exp1(ik,it2,1,3)=4
    else
        exp1(ik,it2,1,3)=5
    end if
end do

!Initialzing the distribution of abilities

do it2=1,nsim
    if(Random2(ik,it2)<Prob_a(1)) then
        exp1(ik,it2,:,2)=1
    elseif((Prob_a(1)<Random2(ik,it2)).AND.(Random2(ik,it2)<(Prob_a(1)+Prob_a(2)))) then
        exp1(ik,it2,:,2)=2
    elseif(((Prob_a(1)+Prob_a(2))<Random2(ik,it2)).AND.(Random2(ik,it2)<(Prob_a(1)+Prob_a(2)+Prob_a(3)))) then
        exp1(ik,it2,:,2)=3
    elseif(((Prob_a(1)+Prob_a(2)+Prob_a(3))<Random2(ik,it2)).AND.(Random2(ik,it2)<(Prob_a(1)+Prob_a(2)+Prob_a(3)+Prob_a(4)))) then
        exp1(ik,it2,:,2)=4
    else
        exp1(ik,it2,:,2)=5
    end if
end do

!Starting to simulate age 20-64, using piecewise linear interpolation of the policy functions

do i=1,T

do it2=1,nsim

dum2=Sim1(ik,it2,i,1)
ia=exp1(ik,it2,i,2)
iu=exp1(ik,it2,i,3)    

!Next period's capit2al
Sim1(ik,it2,i+1,1)=LinInterp(dum2,k_grid,k(:,ia,iu,i),nk)

!This period's consumption
dum4=LinInterp(dum2,k_grid,c(:,ia,iu,i),nk)
Sim1(ik,it2,i,2)=dum4

!Wage, work hours and earnings
Sim1(ik,it2,i,3)=wage(i,a(ia),u(iu))/(1d0+t_employer)
dum5=LinInterp(dum2,k_grid,n(:,ia,iu,i),nk)
dum5=max(dum5,0d0)
Sim1(ik,it2,i,4)=dum5
dum3=dum5*wage(i,a(ia),u(iu))/(1d0+t_employer)
Sim1(ik,it2,i,5)=dum3
Sim1(ik,it2,i,6)=dum3

!Taxes

if(dum3>0d0) then
    Sim1(ik,it2,i,7)=tax_labor(dum3)*dum3
else
    Sim1(ik,it2,i,7)=0d0
end if

Sim1(ik,it2,i,8)=dum4*tc
Sim1(ik,it2,i,9)=dum3*t_employee+t_employer*dum3

end do

!Uppdating the idiosyncratic wage shock

do it2=1,nsim
    iu=exp1(ik,it2,i,3)
    if(Random3(ik,it2,i)<trans_u(iu,1)) then
        exp1(ik,it2,i+1,3)=1
    elseif((trans_u(iu,1)<Random3(ik,it2,i)).AND.(Random3(ik,it2,i)<(trans_u(iu,1)+trans_u(iu,2)))) then
        exp1(ik,it2,i+1,3)=2
    elseif(((trans_u(iu,1)+trans_u(iu,2))<Random3(ik,it2,i)).AND.(Random3(ik,it2,i)<(trans_u(iu,1)+trans_u(iu,2)+trans_u(iu,3)))) then
        exp1(ik,it2,i+1,3)=3
    elseif(((trans_u(iu,1)+trans_u(iu,2)+trans_u(iu,3))<Random3(ik,it2,i)).AND.(Random3(ik,it2,i)<(trans_u(iu,1)+trans_u(iu,2)+trans_u(iu,3)+trans_u(iu,4)))) then
        exp1(ik,it2,i+1,3)=4
    else
        exp1(ik,it2,i+1,3)=5
    end if
end do

end do

!Beginning the simulation for retired households

SimR1(ik,:,1,1)=Sim1(ik,:,T+1,1)

do i=1,36

do it2=1,nsim
    
dum2=SimR1(ik,it2,i,1)
SimR1(ik,it2,i+1,1) = LinInterp(dum2,k_grid,k_ret(:,i),nk)
dum4=LinInterp(dum2,k_grid,c_ret(:,i),nk)
SimR1(ik,it2,i,2)=dum4
SimR1(ik,it2,i,3)=dum4*tc
    
end do

end do

end subroutine Simulation