subroutine SolveActiveLife(ik)
    !This subroutine computes optimal policies at age 64
    use Model_Parameters
    use PolicyFunctions
    use glob0
    use Utilities
    USE CSVAL_INT

    implicit none

    integer, INTENT(IN) :: ik
    integer :: ix,ixd,ia,iu,iaf,iuf,iu2,iu3,j
    integer :: NEQ=0, IERSVR=0, IPACT=0, ISACT=0
    real(8) :: c2, MU2, d1, d2, vp(nu),dum3,dum4,dum5,dum6,y
    real(8) :: ACC=0.0001d0,ERREL=0.0001d0
    real(8) :: P1,P2,P3,P4,V2,V3,dum2,pnt2(3),pnt1(2)

    do ia = 1, na
        do iu = 1, nu
            !Finding optimal capital by golden search
            waged = wage(T-it,a(ia),u(iu))/(1d0+t_employer)
            P1=0.01d0
            P4=min((k_grid(nk)-0.001d0)/(1d0+tc),((k_grid(ik) + Gamma_redistr)*(1d0+r*(1d0-tk))+lumpsum+waged*(1d0-tax_labor(waged)-tSS_employee(waged)))/(1d0+tc))
            do
                P2 = P1 + ((3.0-sqrt(5.0))/2.0)*(P4-P1)
                P3 = P1 + ((sqrt(5.0)-1.0)/2.0)*(P4-P1)

                pnt1 = (/P2, waged/)
                dum4 = min(max(bilin_interp(c_grid, wage_grid, labor, nc, nw, pnt1),0d0),1d0)
                y=dum4*waged
                dum2=((k_grid(ik) + Gamma_redistr)*(1d0+r*(1d0-tk))+lumpsum+y*(1d0-tax_labor(y)-tSS_employee(y))-P2*(1d0+tc))/(1d0+mu)
                V2=Uc(P2)+Ul(dum4)
                V2=V2+beta*OmegaActive(T-it)*D_CSVAL(dum2,BREAK,ev_spln_coefs(:,:,ia,iu,T+1-it))
                if(dum2<0d0) then
                    V2=-999999999d0
                end if

                pnt1 = (/P3, waged/)
                dum4 = min(max(bilin_interp(c_grid, wage_grid, labor, nc, nw, pnt1),0d0),1d0)
                y=dum4*waged
                dum2=((k_grid(ik) + Gamma_redistr)*(1d0+r*(1d0-tk))+lumpsum+y*(1d0-tax_labor(y)-tSS_employee(y))-P3*(1d0+tc))/(1d0+mu)
                V3=Uc(P3)+Ul(dum4)
                V3=V3+beta*OmegaActive(T-it)*D_CSVAL(dum2,BREAK,ev_spln_coefs(:,:,ia,iu,T+1-it))
                if(dum2<0d0) then
                    V3=-999999999d0
                end if

                if (V2 < V3) then
                    P1=P2
                else
                    P4=P3
                end if
                if((P4-P1)<1d-4) exit
            end do

            V(ik,ia,iu,T-it)=V2
            k(ik,ia,iu,T-it)=dum2
            n(ik,ia,iu,T-it)=dum4
            c(ik,ia,iu,T-it)=P2

            if(n(ik,ia,iu,T-it)<0d0) then
                Print *,'ik is',ik
                Print *,'ia is',ia
                Print *,'iu is',iu
                Print *,'n(ik,ia,iu,T-it) is',n(ik,ia,iu,T-it)
                pause
            end if
        end do
    end do


    ev(ik,:,:,T-it)=0d0

    do iu = 1, nu
        do ia = 1, na
            do iu2=1,nu
                ev(ik,ia,iu,T-it)=ev(ik,ia,iu,T-it)+trans_u(iu,iu2)*V(ik,ia,iu2,T-it)
            end do
        end do
    end do
        
end subroutine SolveActiveLife
