subroutine Statistics

!This subroutine computes aggregate statistics from the simulation

use Model_Parameters
use PolicyFunctions
use Utilities
implicit none
integer :: i,ia,iu,ix,um,it2,ik
real(8) :: dum2,dum3,dum4,dum5,dum6,dum7,dum8,dum9,dum10,dum15,dum16,dum17

dum10=0d0

!Computing the weight of each generation

WeightActive(1)=1d0
do i=2,T
    WeightActive(i)=WeightActive(i-1)*OmegaActive(i-1)
end do

WeightRet(1)=WeightActive(T)*OmegaActive(T)
do i=2,Tret
    WeightRet(i)=WeightRet(i-1)*OmegaRet(i-1)
end do

dum2=0d0
dum3=0d0
dum4=0d0
dum5=0d0

!Labor Supply

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,4)*WeightActive(i)
    dum3=dum3+WeightActive(i)
end do
end do

end do

dum2=dum2/dum3

Print *,'Labor supply is',dum2

dum10=dum10+((dum2-0.2820d0)/0.2820d0)**2

dum2=0d0
dum3=0d0
dum4=0d0
dum5=0d0

!Variance of log earnings

dum2=0d0
dum3=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    if(Sim1(it2,it,i,5)>0d0) then
    dum2=dum2+log(Sim1(it2,it,i,5))*WeightActive(i)
    dum3=dum3+1d0*WeightActive(i)
    end if
end do
end do

end do

dum2=dum2/dum3

do i=1,T

do it2=1,nsim2    
do it=1,nsim
    if(Sim1(it2,it,i,5)>0d0) then
        dum4=dum4+((log(Sim1(it2,it,i,5))-dum2)**2)*WeightActive(i)
    end if
end do
end do

end do

dum4=dum4/dum3

Print *,'Variance of log earnings is',dum4

!Variance of log wage

dum2=0d0
dum3=0d0
dum4=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+log(Sim1(it2,it,i,3))*WeightActive(i)
    dum3=dum3+1d0*WeightActive(i)
end do
end do

end do

dum2=dum2/dum3

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum4=dum4+((log(Sim1(it2,it,i,3))-dum2)**2)*WeightActive(i)
end do
end do

end do

dum4=dum4/dum3

Print *,'Variance of log wage is',dum4

!Average wage

dum2=0d0
dum3=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,3)*WeightActive(i)
    dum3=dum3+1d0*WeightActive(i)
end do
end do

end do

dum2=dum2/dum3

Print *,'Average wage is',dum2

!Average earnings

dum2=0d0
dum3=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,5)*WeightActive(i)
    dum3=dum3+1d0*WeightActive(i)
end do
end do

end do

dum2=dum2/dum3

Print *,'Average earnings is',dum2

!Total labor income taxes and tax revenue

dum2=0d0
dum3=0d0
dum4=0d0
dum5=0d0
dum7=0d0
dum15=0d0
dum16=0d0
dum17=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum5=dum5+1d0*WeightActive(i)
    dum2=dum2+Sim1(it2,it,i,6)*(1d0+t_employer)*WeightActive(i)
    dum7=dum7+Sim1(it2,it,i,7)*WeightActive(i)
    dum15=dum15+Sim1(it2,it,i,9)*WeightActive(i)
    dum4=dum4+Sim1(it2,it,i,9)*WeightActive(i)+Sim1(it2,it,i,7)*WeightActive(i)
    dum3=dum3+Sim1(it2,it,i,9)*WeightActive(i)+Sim1(it2,it,i,7)*WeightActive(i)+Sim1(it2,it,i,8)*WeightActive(i)+Sim1(it2,it,i,1)*WeightActive(i)*r*tk
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum5=dum5+1d0*WeightRet(i)
    dum3=dum3+SimR1(it2,it,i,3)*WeightRet(i)+SimR1(it2,it,i,1)*WeightRet(i)*r*tk
end do
end do

end do

Print *,'Labor income tax rate including TSS is',dum4/dum2

Print *,'Tax revenue per capita including TSS is',dum3/dum5


!Social security

dum2=0d0
dum3=0d0
dum4=0d0
dum5=0d0
dum7=0d0
dum15=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum4=dum4+Sim1(it2,it,i,9)*WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum5=dum5+1d0*WeightRet(i)
end do
end do

end do

dum4=dum4/dum5

Print *,'Net Social Security income per retired individual',dum4
Print *,'Pension',Psi_pension

epsilon=Psi_pension-dum4

Psi_pension=Psi_pension-0.5d0*(Psi_pension-dum4)

!Savings

dum2=0d0
dum3=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,1)*WeightActive(i)
    dum3=dum3+WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+SimR1(it2,it,i,1)*WeightRet(i)
    dum3=dum3+WeightRet(i)
end do
end do

end do

dum2=dum2/dum3

Print *,'Savings per capita is',dum2
dum6=dum2

! Assets for redistribution

dum2=0d0
dum3=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i+1,1)*WeightActive(i)*(1d0-OmegaActive(i))
    dum3=dum3+1d0*WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+SimR1(it2,it,i+1,1)*WeightRet(i)*(1d0-OmegaRet(i))
    dum3=dum3+1d0*WeightRet(i)
end do
end do

end do

dum2=dum2/dum3

Print *,'Assets per capita to be redistributed',dum2
Print *,'Gamma_redistr',Gamma_redistr

epsilon2=Gamma_redistr-dum2

Gamma_redistr=Gamma_redistr-0.5d0*(Gamma_redistr-dum2)

! Capital tax

dum2=0d0
dum3=0d0

do i=1,T

do it2=1,nsim2 
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,1)*WeightActive(i)*r*tk
    dum3=dum3+WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+SimR1(it2,it,i,1)*WeightRet(i)*r*tk
    dum3=dum3+WeightRet(i)
end do
end do

end do

dum2=dum2/dum3

Print *,'Capital tax per capita is',dum2

dum7=dum2

!Consumption

dum2=0d0
dum3=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,2)*WeightActive(i)
    dum3=dum3+WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+SimR1(it2,it,i,2)*WeightRet(i)
    dum3=dum3+WeightRet(i)
end do
end do

end do

dum2=dum2/dum3

Print *,'Consumption per capita is',dum2

dum2=0d0
dum3=0d0

!Consumption tax

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,8)*WeightActive(i)
    dum3=dum3+WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+SimR1(it2,it,i,3)*WeightRet(i)
    dum3=dum3+WeightRet(i)
end do
end do

end do

dum2=dum2/dum3

Print *,'Consumption tax per capita is',dum2

!Labor income tax

dum4=0d0
dum5=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum4=dum4+Sim1(it2,it,i,7)*WeightActive(i)
    dum5=dum5+WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum5=dum5+WeightRet(i)
end do
end do

end do

dum4=dum4/dum5

Print *,'Labor income tax per capita is',dum4

Print *,'Tax revenue per capita is',dum4+dum2+dum7

dum5=dum4+dum2

dum2=0d0
dum3=0d0

!GDP per capita

dum9=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum3=dum3+WeightActive(i)
    dum9=dum9+(Sim1(it2,it,i,6)*(1d0+t_employer)/w)*WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum3=dum3+WeightRet(i)
end do
end do

end do

Print *,'Ltot is',dum9

dum3=((ratio*dum9)**alpha)*(dum9**(1-alpha))/dum3

Print *,'GDP per capita is',dum3

!Government Budget

lumpsumdum=(dum5+dum7)+mu*debttoGDP*dum3-(r*debttoGDP*dum3+2*milspendtoGDP*dum3)

Print *,'Net revenue is',lumpsumdum
Print *,'Lumpsum is',lumpsum

epsilon3=lumpsum-lumpsumdum

lumpsum=lumpsum-0.5d0*(lumpsum-lumpsumdum)

!Labor income tax level

dum2=0d0
dum3=0d0
dum4=0d0
dum5=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,6)*WeightActive(i)
    dum3=dum3+WeightActive(i)
end do
end do

end do

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum4=dum4+Sim1(it2,it,i,7)*WeightActive(i)
end do
end do

end do

Print *,'Average labor income tax rate is',dum4/dum2

Print *,'Average individual earnings is',dum2/dum3

epsilon5=AE-dum2/dum3

AE=AE-0.5d0*(AE-dum2/dum3)

!Prices

dum2=0d0
dum3=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,1)*WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+SimR1(it2,it,i,1)*WeightRet(i)    
end do
end do

end do

dum6=dum2-debttoGDP*((ratio*dum9)**(alpha))*(dum9**(1d0-alpha))

!Print *,'Ktot is',dum6

ratiodum=dum6/dum9

Print *,'Ratio between capital and labor is',ratiodum

Print *,'Implied wage is',(1d0-alpha)*ratiodum**alpha
Print *,'Implied interest is',alpha*ratiodum**(alpha-1d0)-delta

Print *,'Wage is',w
Print *,'Interest is',r

Print *,'K/Y is',ratiodum**(1d0-alpha)

dum10=dum10+(((ratiodum**(1d0-alpha))-2.6399)/2.6399)**2

Print *,'FCN is',dum10

dum9=maxval(Sim1(:,:,:,1))

dum9=max(dum9,maxval(SimR1(:,:,:,1)))

Print *,'Max savings is',dum9

end subroutine Statistics


subroutine Statistics2

!This subroutine computes aggregate statistics from the simulation

use Model_Parameters
use PolicyFunctions
use Utilities
implicit none
integer :: i,ia,iu,ix,um,it2,ik
real(8) :: dum2,dum3,dum4,dum5,dum6,dum7,dum8,dum9,dum10,dum15,dum16,dum17

dum10=0d0

!Computing the weight of each generation

WeightActive(1)=1d0
do i=2,T
    WeightActive(i)=WeightActive(i-1)*OmegaActive(i-1)
end do

WeightRet(1)=WeightActive(T)*OmegaActive(T)
do i=2,Tret
    WeightRet(i)=WeightRet(i-1)*OmegaRet(i-1)
end do

dum2=0d0
dum3=0d0
dum4=0d0
dum5=0d0

!Labor Supply

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,4)*WeightActive(i)
    dum3=dum3+WeightActive(i)
end do
end do

end do

dum2=dum2/dum3

Write(51,*),'Labor supply is',dum2

dum10=dum10+((dum2-0.2820d0)/0.2820d0)**2

dum2=0d0
dum3=0d0
dum4=0d0
dum5=0d0

!Variance of log earnings

dum2=0d0
dum3=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    if(Sim1(it2,it,i,5)>0d0) then
    dum2=dum2+log(Sim1(it2,it,i,5))*WeightActive(i)
    dum3=dum3+1d0*WeightActive(i)
    end if
end do
end do

end do

dum2=dum2/dum3

do i=1,T

do it2=1,nsim2    
do it=1,nsim
    if(Sim1(it2,it,i,5)>0d0) then
        dum4=dum4+((log(Sim1(it2,it,i,5))-dum2)**2)*WeightActive(i)
    end if
end do
end do

end do

dum4=dum4/dum3

Write(51,*),'Variance of log earnings is',dum4

!Variance of log wage

dum2=0d0
dum3=0d0
dum4=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+log(Sim1(it2,it,i,3))*WeightActive(i)
    dum3=dum3+1d0*WeightActive(i)
end do
end do

end do

dum2=dum2/dum3

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum4=dum4+((log(Sim1(it2,it,i,3))-dum2)**2)*WeightActive(i)
end do
end do

end do

dum4=dum4/dum3

Write(51,*),'Variance of log wage is',dum4

!Average wage

dum2=0d0
dum3=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,3)*WeightActive(i)
    dum3=dum3+1d0*WeightActive(i)
end do
end do

end do

dum2=dum2/dum3

Write(51,*),'Average wage is',dum2

!Average earnings

dum2=0d0
dum3=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,5)*WeightActive(i)
    dum3=dum3+1d0*WeightActive(i)
end do
end do

end do

dum2=dum2/dum3

Write(51,*),'Average earnings is',dum2

!Total labor income taxes and tax revenue

dum2=0d0
dum3=0d0
dum4=0d0
dum5=0d0
dum7=0d0
dum15=0d0
dum16=0d0
dum17=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum5=dum5+1d0*WeightActive(i)
    dum2=dum2+Sim1(it2,it,i,6)*(1d0+t_employer)*WeightActive(i)
    dum7=dum7+Sim1(it2,it,i,7)*WeightActive(i)
    dum15=dum15+Sim1(it2,it,i,9)*WeightActive(i)
    dum4=dum4+Sim1(it2,it,i,9)*WeightActive(i)+Sim1(it2,it,i,7)*WeightActive(i)
    dum3=dum3+Sim1(it2,it,i,9)*WeightActive(i)+Sim1(it2,it,i,7)*WeightActive(i)+Sim1(it2,it,i,8)*WeightActive(i)+Sim1(it2,it,i,1)*WeightActive(i)*r*tk
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum5=dum5+1d0*WeightRet(i)
    dum3=dum3+SimR1(it2,it,i,3)*WeightRet(i)+SimR1(it2,it,i,1)*WeightRet(i)*r*tk
end do
end do

end do

Write(51,*),'Labor income tax rate including TSS is',dum4/dum2

Write(51,*),'Tax revenue per capita including TSS is',dum3/dum5


!Social security

dum2=0d0
dum3=0d0
dum4=0d0
dum5=0d0
dum7=0d0
dum15=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum4=dum4+Sim1(it2,it,i,9)*WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum5=dum5+1d0*WeightRet(i)
end do
end do

end do

dum4=dum4/dum5

Write(51,*),'Net Social Security income per retired individual',dum4
Write(51,*),'Pension',Psi_pension

epsilon=Psi_pension-dum4

Psi_pension=Psi_pension-0.5d0*(Psi_pension-dum4)

!Savings

dum2=0d0
dum3=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,1)*WeightActive(i)
    dum3=dum3+WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+SimR1(it2,it,i,1)*WeightRet(i)
    dum3=dum3+WeightRet(i)
end do
end do

end do

dum2=dum2/dum3

Write(51,*),'Savings per capita is',dum2
dum6=dum2

! Assets for redistribution

dum2=0d0
dum3=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i+1,1)*WeightActive(i)*(1d0-OmegaActive(i))
    dum3=dum3+1d0*WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+SimR1(it2,it,i+1,1)*WeightRet(i)*(1d0-OmegaRet(i))
    dum3=dum3+1d0*WeightRet(i)
end do
end do

end do

dum2=dum2/dum3

Write(51,*),'Assets per capita to be redistributed',dum2
Write(51,*),'Gamma_redistr',Gamma_redistr

epsilon2=Gamma_redistr-dum2

Gamma_redistr=Gamma_redistr-0.5d0*(Gamma_redistr-dum2)

! Capital tax

dum2=0d0
dum3=0d0

do i=1,T

do it2=1,nsim2 
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,1)*WeightActive(i)*r*tk
    dum3=dum3+WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+SimR1(it2,it,i,1)*WeightRet(i)*r*tk
    dum3=dum3+WeightRet(i)
end do
end do

end do

dum2=dum2/dum3

Write(51,*),'Capital tax per capita is',dum2

dum7=dum2

!Consumption

dum2=0d0
dum3=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,2)*WeightActive(i)
    dum3=dum3+WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+SimR1(it2,it,i,2)*WeightRet(i)
    dum3=dum3+WeightRet(i)
end do
end do

end do

dum2=dum2/dum3

Write(51,*),'Consumption per capita is',dum2

dum2=0d0
dum3=0d0

!Consumption tax

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,8)*WeightActive(i)
    dum3=dum3+WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+SimR1(it2,it,i,3)*WeightRet(i)
    dum3=dum3+WeightRet(i)
end do
end do

end do

dum2=dum2/dum3

Write(51,*),'Consumption tax per capita is',dum2

!Labor income tax

dum4=0d0
dum5=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum4=dum4+Sim1(it2,it,i,7)*WeightActive(i)
    dum5=dum5+WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum5=dum5+WeightRet(i)
end do
end do

end do

dum4=dum4/dum5

Write(51,*),'Labor income tax per capita is',dum4

Write(51,*),'Tax revenue per capita is',dum4+dum2+dum7

dum5=dum4+dum2

dum2=0d0
dum3=0d0

!GDP per capita

dum9=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum3=dum3+WeightActive(i)
    dum9=dum9+(Sim1(it2,it,i,6)*(1d0+t_employer)/w)*WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum3=dum3+WeightRet(i)
end do
end do

end do

Write(51,*),'Ltot is',dum9

dum3=((ratio*dum9)**alpha)*(dum9**(1-alpha))/dum3

Write(51,*),'GDP per capita is',dum3

!Government Budget

lumpsumdum=(dum5+dum7)+mu*debttoGDP*dum3-(r*debttoGDP*dum3+2*milspendtoGDP*dum3)

Write(51,*),'Net revenue is',lumpsumdum
Write(51,*),'Lumpsum is',lumpsum

epsilon3=lumpsum-lumpsumdum

lumpsum=lumpsum-0.5d0*(lumpsum-lumpsumdum)

!Labor income tax level

dum2=0d0
dum3=0d0
dum4=0d0
dum5=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,6)*WeightActive(i)
    dum3=dum3+WeightActive(i)
end do
end do

end do

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum4=dum4+Sim1(it2,it,i,7)*WeightActive(i)
end do
end do

end do

Write(51,*),'Average labor income tax rate is',dum4/dum2

Write(51,*),'Average individual earnings is',dum2/dum3

epsilon5=AE-dum2/dum3

AE=AE-0.5d0*(AE-dum2/dum3)

!Prices

dum2=0d0
dum3=0d0

do i=1,T

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+Sim1(it2,it,i,1)*WeightActive(i)
end do
end do

end do

do i=1,36

do it2=1,nsim2
do it=1,nsim
    dum2=dum2+SimR1(it2,it,i,1)*WeightRet(i)    
end do
end do

end do

dum6=dum2-debttoGDP*((ratio*dum9)**(alpha))*(dum9**(1d0-alpha))

!Write(51,*),'Ktot is',dum6

ratiodum=dum6/dum9

Write(51,*),'Ratio between capital and labor is',ratiodum

Write(51,*),'Implied wage is',(1d0-alpha)*ratiodum**alpha
Write(51,*),'Implied interest is',alpha*ratiodum**(alpha-1d0)-delta

Write(51,*),'Wage is',w
Write(51,*),'Interest is',r

Write(51,*),'K/Y is',ratiodum**(1d0-alpha)

dum10=dum10+(((ratiodum**(1d0-alpha))-2.6399)/2.6399)**2

Write(51,*),'FCN is',dum10

dum9=maxval(Sim1(:,:,:,1))

dum9=max(dum9,maxval(SimR1(:,:,:,1)))

Write(51,*),'Max savings is',dum9

end subroutine Statistics2
