subroutine lsupply(ik)
    !This subroutine computes optimal policies durin active worklife.
    use Model_Parameters
    use PolicyFunctions
    use glob0
    use Utilities
    USE LCONF_INT
    USE CSVAL_INT
    USE NEQNF_INT
    USE ERSET_INT

    implicit none

    integer, INTENT(IN) :: ik
    integer :: ium,iu2,iu3
    real(8), dimension (:,:,:,:,:,:), allocatable :: ce,cu,ke,ku,nem,nef,num,nuf,ve,vu
    real(8), dimension (:,:,:,:,:), allocatable :: ces,cus,kes,kus,nes,nus,ves,vus
    real(8), dimension (:), allocatable :: Expdum
    integer :: NEQ=0, IERSVR=0, IPACT=0, ISACT=0
    real(8) :: c2, MU2, d1, d2, vp(nu),dum3,dum4,dum5,dum6,y
    real(8) :: ACC=0.0001d0,ERREL=0.0001d0
    real(8) :: P1,P2,P3,P4,V2,V3,dum2
    EXTERNAL laborf

    CALL ERSET(IERSVR, IPACT, ISACT)

    dum=c_grid(ik)
    do ium=1,nw
        waged=wage_grid(ium)
        XGUESS(1)=0.99d0
        ITMAX=1000000
        !For each level of capital we call D_LCONF to find optimal labor
        CALL D_NEQNF(laborf, SOL, ERREL,ITMAX=ITMAX,XGUESS=XGUESS,FNORM=FNORM)
        dum4=min(SOL(1),1d0)
        dum6=FNORM
        if(dum6>10d0*(ERREL**2)) then
            XGUESS(1)=0.01d0
            ITMAX=1000000
            CALL D_NEQNF(laborf, SOL, ERREL,ITMAX=ITMAX,XGUESS=XGUESS,FNORM=FNORM)
            if(FNORM<dum6) then
                dum4=min(SOL(1),1d0)
                dum6=FNORM
            end if
        end if
        if(dum6>10d0*(ERREL**2)) then
            XGUESS(1)=0.3d0
            ITMAX=1000000
            CALL D_NEQNF(laborf, SOL, ERREL,ITMAX=ITMAX,XGUESS=XGUESS,FNORM=FNORM)
            if(FNORM<dum6) then
                dum4=min(SOL(1),1d0)
                dum6=FNORM
            end if
        end if

        labor(ik,ium)=dum4
    end do

end subroutine lsupply
