 
 include 'link_fnl_shared.h'
 
!
! old:
! include 'link_f90_dll_smp.h'
      
! Add this source to your project to correct the problem
! that, for a Debug build for certain projects using the
! IMSL Fortran libraries, the linker complains of an
! unresolved external symbol __imp__MPIPRIV
BLOCK DATA MPIPRIV_DEF
COMMON /MPIPRIV/ DUMMY
!DEC$ ATTRIBUTES ALIAS:"__imp__MPIPRIV" :: /MPIPRIV/
END BLOCK DATA MPIPRIV_DEF


 program Laffer
        
        use Utilities
        use Model_Parameters
        use PolicyFunctions
        USE CSINT_INT
        USE CSVAL_INT
        implicit none
        integer :: ik,tprint,it2,it3,it4,ium,iam,iuf,iaf,ix,j,iu2,ik2
        real(8) :: dum,dum2
        integer :: iter_outer
        character(8) :: date
        character(10) :: time
        logical :: testing

        !testing = .true.
        
        call OMP_SET_NUM_THREADS(8)
        
        call date_and_time(DATE=date,TIME=time)
        
        call Initialize
        !open(51, file='simulated_results.txt')
        !write(51,*), 'Started on ', date, ', at ', time
        !tax_level_scale = 0.64d0
        !tax_level_scale = 1.15d0
        !open(61, file='tax_prog_scale.txt')
        !read(61,*) tax_prog_scale
        !close(61)
        
        !do while (tax_level_scale > 0.28d0)

            !write(51,*), '=============================='
            !write(51,*), 'Tax function parameters:'
            !write(51,*), 'level = ', tax_level_scale
            !write(51,*), 'Progressivity = ', tax_prog_scale
            !write(51,*), '=============================='
            !
            !print *, '=============================='
            !print *, 'Tax function parameters:'
            !print *, 'level = ', tax_level_scale
            !print *, 'Progressivity = ', tax_prog_scale
            !print *, '=============================='

            !Compute optimal policies in retirement
            iter_outer = 1
            epsilon4 = 1d0

            do while(abs(epsilon4)>0.001d0 .and. iter_outer <= 80)

                epsilon=1d0
                epsilon2=1d0
                epsilon3=1d0
                epsilon5=1d0

                iter=0

                do while((abs(epsilon)>0.001d0).OR.(abs(epsilon2)>0.001d0).OR.(abs(epsilon3)>0.001d0).OR.(abs(epsilon5)>0.001d0))

                    iter=iter+1

                    do it=1,Tret

                        !$OMP PARALLEL PRIVATE(ik)
                        !$OMP DO SCHEDULE(DYNAMIC)
                        do ik=1,nk 
                            call SolveInRetirement(ik)
                        end do
                        !$OMP END DO    
                        !$OMP END PARALLEL

                        ! Compute spline coefficients:

                        call d_csint(k_grid, v_ret(:,Tret-it+1), BREAK, ev_spln_coefs_ret(:,:,Tret-it+1))

                    end do

                    dum2= 1.5d0*wage(40,a(5),u(5))/(1d0+t_employer)
                    call MakeGrid(nw,wage_grid,0.01d0,dum2,2d0)

                    !$OMP PARALLEL PRIVATE(ik)
                    !$OMP DO SCHEDULE(DYNAMIC)
                    do ik=1,nc
                        call lsupply(ik)
                    end do
                    !$OMP END DO    
                    !$OMP END PARALLEL

                    !if (testing == .true.) then
                        !open(51,file='Tests/labor.txt')
                        !open(52,file='Tests/cgrid.txt')
                        !open(53,file='Tests/wgrid.txt')
                        !do ik = 1, nc
                            !write(51,'(<nw>f12.6)'), labor(ik,:)
                            !write(52,'(f12.6)'), c_grid(ik)
                        !end do
                        !do ik = 1, nw
                            !write(53,'(f12.6)'), wage_grid(ik)
                        !end do
                        !close(51)
                        !close(52)
                        !close(53)
                    !end if


                    !Compute optimal policies at age 64

                    !$OMP PARALLEL PRIVATE(ik)
                    !$OMP DO SCHEDULE(DYNAMIC)
                    do ik=1,nk
                        call Solvelastactive(ik)
                    end do
                    !$OMP END DO    
                    !$OMP END PARALLEL

                    it=0

                    !$OMP PARALLEL PRIVATE(ium)
                    !$OMP DO SCHEDULE(DYNAMIC)
                    do ium = 1, nu
                        call splines(ium)
                    end do
                    !$OMP END DO    
                    !$OMP END PARALLEL

                    do it=1,T-1

                        !$OMP PARALLEL PRIVATE(ik)
                        !$OMP DO SCHEDULE(DYNAMIC)
                        do ik=1,nk
                            call SolveActiveLife(ik)
                        end do
                        !$OMP END DO    
                        !$OMP END PARALLEL

                        !if (testing == .true.) then
                            !open(51, file='Tests/ev.txt')
                            !open(52, file='Tests/kgrid.txt')
                            !do ik = 1, nk
                                !write(51,'(<na>f12.6)'), ev(ik,:,nu/2,T-it)
                                !write(52,'(f12.6)'), k_grid(ik)
                            !end do
                            !close(51)
                            !close(52)
                        !end if

                        !$OMP PARALLEL PRIVATE(ium)
                        !$OMP DO SCHEDULE(DYNAMIC)
                        do ium = 1, nu
                            call splines(ium)
                        end do
                        !$OMP END DO    
                        !$OMP END PARALLEL

                    end do

                    !$OMP PARALLEL PRIVATE(ik)
                    !$OMP DO SCHEDULE(DYNAMIC)
                    do ik=1,nsim2
                        call Simulation(ik)
                    end do
                    !$OMP END DO    
                    !$OMP END PARALLEL

                    call Statistics

                end do    

                epsilon4=ratio-ratiodum

                Print *,'epsilon4 is',epsilon4

                ratio=ratio-0.1d0*(ratio-ratiodum)

                w=(1d0-alpha)*ratio**alpha
                r=alpha*ratio**(alpha-1d0)-delta
                iter_outer = iter_outer + 1
                write(51,*), 'iter_outer = ', iter_outer
                write(51,*), 'epsilon4', epsilon4

                if (abs(epsilon4) <= 0.001d0 .or. iter_outer > 80) call Statistics2

            end do

        !    tax_level_scale = tax_level_scale - 0.01d0
        !    call update_thetas(tax_level_scale, tax_prog_scale)
        !
        !end do

        contains
        
        subroutine Initialize()
            
            USE ANORDF_INT
            implicit none
            
            
            
            allocate(v(nk,na,nu,T))
            allocate(ev(nk,na,nu,T))
            allocate(c(nk,na,nu,T))
            allocate(k(nk,na,nu,T))
            allocate(n(nk,na,nu,T))
            allocate(ev_spln_coefs(4,nk,na,nu,T))
            allocate(v_spln_coefs(4,nk,na,nu,T))
            
            allocate(Sim1(nsim2,nsim,46,10))
            allocate(exp1(nsim2,nsim,46,5))
            allocate(SimR1(nsim2,nsim,37,4))
            allocate(Random3(nsim2,nsim,45))
            allocate(Random1(nsim2,nsim))
            allocate(Random2(nsim2,nsim))
            
            allocate(a(na))
            allocate(Prob_a(na))
            allocate(u(nu))
            allocate(Prob_u(nu))
            allocate(trans_u(nu,nu))
            allocate(trans_a(na,na))
            allocate(OmegaRet(Tret))
            allocate(OmegaActive(T))
            allocate(WeightRet(Tret))
            allocate(WeightActive(T))
    
            allocate(labor(nc,nw))
            
            allocate(c_grid(nc))
            allocate(wage_grid(nw))
            allocate(k_grid(nk))
            allocate(ev_spln_coefs_ret(4,nk,Tret))
            allocate(c_ret(nk,Tret))
            allocate(v_ret(nk,Tret))
            allocate(k_ret(nk,Tret))
            allocate(break(nk))
            
            trans_u = 0d0
            prob_u=0d0
            trans_a = 0d0
            prob_a=0d0
            gammaw(:) = (/ 0.2389733d0, -0.0044777d0, 0.0000282d0 /)
            theta(:) = (/ 0.881821147*tax_level_scale, 0.132858656*tax_prog_scale /)
            !theta(:) = (/ 0.94077237*tax_level_scale, 0.15846645*tax_prog_scale /)
            !theta(:) = (/ 1.006167*tax_level_scale, 0.20363833*tax_prog_scale /)
            !thetas(:) = (/ 0.81773322*tax_level_scale, 0.11060017*tax_prog_scale /)
            !theta(1,:) = (/ 0.7827*tax_level_scale, 0.1667*tax_prog_scale /)
            !theta(2,:) = (/ 0.8657*tax_level_scale, 0.2405*tax_prog_scale /)
            !theta(3,:) = (/ 0.9194*tax_level_scale, 0.2764*tax_prog_scale /)
            !thetas(:) = (/ 0.7170*tax_level_scale, 0.2176*tax_prog_scale /)
            AE = 0.808266673596142d0
            r=alpha*ratio**(alpha-1d0)-delta
            w=(1d0-alpha)*ratio**alpha
            call MakeGrid(nk,k_grid,0d0,60d0,3d0)
            call MakeGrid(nc,c_grid,0.01d0,60d0,3d0)
            
            ! Filling in survival probabilities
            
            OmegaActive=1d0
            
            OmegaRet(1)=1d0-0.014319d0
            OmegaRet(2)=1d0-0.015540d0
            OmegaRet(3)=1d0-0.016920d0
            OmegaRet(4)=1d0-0.018448d0
            OmegaRet(5)=1d0-0.020170d0
            OmegaRet(6)=1d0-0.022022d0
            OmegaRet(7)=1d0-0.023973d0
            OmegaRet(8)=1d0-0.026203d0
            OmegaRet(9)=1d0-0.028771d0
            OmegaRet(10)=1d0-0.031629d0
            OmegaRet(11)=1d0-0.034611d0
            OmegaRet(12)=1d0-0.037710d0
            OmegaRet(13)=1d0-0.041264d0
            OmegaRet(14)=1d0-0.045405d0
            OmegaRet(15)=1d0-0.050128d0
            OmegaRet(16)=1d0-0.055339d0
            OmegaRet(17)=1d0-0.061005d0
            OmegaRet(18)=1d0-0.067396d0
            OmegaRet(19)=1d0-0.074476d0
            OmegaRet(20)=1d0-0.082272d0
            OmegaRet(21)=1d0-0.091816d0
            OmegaRet(22)=1d0-0.101898d0
            OmegaRet(23)=1d0-0.112870d0
            OmegaRet(24)=1d0-0.124763d0
            OmegaRet(25)=1d0-0.137597d0
            OmegaRet(26)=1d0-0.151383d0
            OmegaRet(27)=1d0-0.166117d0
            OmegaRet(28)=1d0-0.181778d0
            OmegaRet(29)=1d0-0.198331d0
            OmegaRet(30)=1d0-0.215721d0
            OmegaRet(31)=1d0-0.233874d0
            OmegaRet(32)=1d0-0.252699d0
            OmegaRet(33)=1d0-0.272086d0
            OmegaRet(34)=1d0-0.291912d0
            OmegaRet(35)=1d0-0.312040d0
            OmegaRet(36)=1d0-1d0
            
    U(1)=-(3D0/2D0)*SQRT((sigma_u**2)/(1.0-(rho_u**2)))
    U(2)=-(3D0/4D0)*SQRT((sigma_u**2)/(1.0-(rho_u**2)))
    U(3)=0D0
    U(4)=(3D0/4D0)*SQRT((sigma_u**2)/(1.0-(rho_u**2)))
    U(5)=(3D0/2D0)*SQRT((sigma_u**2)/(1.0-(rho_u**2)))
    dum=(5D-1)*(3D0/4D0)*SQRT((sigma_u**2)/(1.0-(rho_u**2)))
    
    trans_u(1,1)=D_ANORDF((u(1)-rho_u*u(1)+dum)/sigma_u)
    trans_u(2,1)=D_ANORDF((u(1)-rho_u*u(2)+dum)/sigma_u)
    trans_u(3,1)=D_ANORDF((u(1)-rho_u*u(3)+dum)/sigma_u)
    trans_u(4,1)=D_ANORDF((u(1)-rho_u*u(4)+dum)/sigma_u)
    trans_u(5,1)=D_ANORDF((u(1)-rho_u*u(5)+dum)/sigma_u)
    trans_u(1,2)=D_ANORDF((u(2)-rho_u*u(1)+dum)/sigma_u)-D_ANORDF((u(2)-rho_u*u(1)-dum)/sigma_u)
    trans_u(2,2)=D_ANORDF((u(2)-rho_u*u(2)+dum)/sigma_u)-D_ANORDF((u(2)-rho_u*u(2)-dum)/sigma_u)
    trans_u(3,2)=D_ANORDF((u(2)-rho_u*u(3)+dum)/sigma_u)-D_ANORDF((u(2)-rho_u*u(3)-dum)/sigma_u)
    trans_u(4,2)=D_ANORDF((u(2)-rho_u*u(4)+dum)/sigma_u)-D_ANORDF((u(2)-rho_u*u(4)-dum)/sigma_u)
    trans_u(5,2)=D_ANORDF((u(2)-rho_u*u(5)+dum)/sigma_u)-D_ANORDF((u(2)-rho_u*u(5)-dum)/sigma_u)
    trans_u(1,3)=D_ANORDF((u(3)-rho_u*u(1)+dum)/sigma_u)-D_ANORDF((u(3)-rho_u*u(1)-dum)/sigma_u)
    trans_u(2,3)=D_ANORDF((u(3)-rho_u*u(2)+dum)/sigma_u)-D_ANORDF((u(3)-rho_u*u(2)-dum)/sigma_u)
    trans_u(3,3)=D_ANORDF((u(3)-rho_u*u(3)+dum)/sigma_u)-D_ANORDF((u(3)-rho_u*u(3)-dum)/sigma_u)
    trans_u(4,3)=D_ANORDF((u(3)-rho_u*u(4)+dum)/sigma_u)-D_ANORDF((u(3)-rho_u*u(4)-dum)/sigma_u)
    trans_u(5,3)=D_ANORDF((u(3)-rho_u*u(5)+dum)/sigma_u)-D_ANORDF((u(3)-rho_u*u(5)-dum)/sigma_u)
    trans_u(1,4)=D_ANORDF((u(4)-rho_u*u(1)+dum)/sigma_u)-D_ANORDF((u(4)-rho_u*u(1)-dum)/sigma_u)
    trans_u(2,4)=D_ANORDF((u(4)-rho_u*u(2)+dum)/sigma_u)-D_ANORDF((u(4)-rho_u*u(2)-dum)/sigma_u)
    trans_u(3,4)=D_ANORDF((u(4)-rho_u*u(3)+dum)/sigma_u)-D_ANORDF((u(4)-rho_u*u(3)-dum)/sigma_u)
    trans_u(4,4)=D_ANORDF((u(4)-rho_u*u(4)+dum)/sigma_u)-D_ANORDF((u(4)-rho_u*u(4)-dum)/sigma_u)
    trans_u(5,4)=D_ANORDF((u(4)-rho_u*u(5)+dum)/sigma_u)-D_ANORDF((u(4)-rho_u*u(5)-dum)/sigma_u)
    trans_u(1,5)=1D0-D_ANORDF((u(5)-rho_u*u(1)-dum)/sigma_u)
    trans_u(2,5)=1D0-D_ANORDF((u(5)-rho_u*u(2)-dum)/sigma_u)
    trans_u(3,5)=1D0-D_ANORDF((u(5)-rho_u*u(3)-dum)/sigma_u)
    trans_u(4,5)=1D0-D_ANORDF((u(5)-rho_u*u(4)-dum)/sigma_u)
    trans_u(5,5)=1D0-D_ANORDF((u(5)-rho_u*u(5)-dum)/sigma_u)
    
    prob_u=1D0/5D0
    
    do it=1,100
        prob_u(:)=MATMUL(prob_u(:),trans_u(:,:))
    end do
    
   
    A(1)=-(3D0/2D0)*SQRT((sigma_a**2)/(1.0-(rho_a**2)))
    A(2)=-(3D0/4D0)*SQRT((sigma_a**2)/(1.0-(rho_a**2)))
    A(3)=0D0
    A(4)=(3D0/4D0)*SQRT((sigma_a**2)/(1.0-(rho_a**2)))
    A(5)=(3D0/2D0)*SQRT((sigma_a**2)/(1.0-(rho_a**2)))
    dum=(5D-1)*(3D0/4D0)*SQRT((sigma_a**2)/(1.0-(rho_a**2)))
    
    trans_a(1,1)=D_ANORDF((a(1)-rho_a*a(1)+dum)/sigma_a)
    trans_a(2,1)=D_ANORDF((a(1)-rho_a*a(2)+dum)/sigma_a)
    trans_a(3,1)=D_ANORDF((a(1)-rho_a*a(3)+dum)/sigma_a)
    trans_a(4,1)=D_ANORDF((a(1)-rho_a*a(4)+dum)/sigma_a)
    trans_a(5,1)=D_ANORDF((a(1)-rho_a*a(5)+dum)/sigma_a)
    trans_a(1,2)=D_ANORDF((a(2)-rho_a*a(1)+dum)/sigma_a)-D_ANORDF((a(2)-rho_a*a(1)-dum)/sigma_a)
    trans_a(2,2)=D_ANORDF((a(2)-rho_a*a(2)+dum)/sigma_a)-D_ANORDF((a(2)-rho_a*a(2)-dum)/sigma_a)
    trans_a(3,2)=D_ANORDF((a(2)-rho_a*a(3)+dum)/sigma_a)-D_ANORDF((a(2)-rho_a*a(3)-dum)/sigma_a)
    trans_a(4,2)=D_ANORDF((a(2)-rho_a*a(4)+dum)/sigma_a)-D_ANORDF((a(2)-rho_a*a(4)-dum)/sigma_a)
    trans_a(5,2)=D_ANORDF((a(2)-rho_a*a(5)+dum)/sigma_a)-D_ANORDF((a(2)-rho_a*a(5)-dum)/sigma_a)
    trans_a(1,3)=D_ANORDF((a(3)-rho_a*a(1)+dum)/sigma_a)-D_ANORDF((a(3)-rho_a*a(1)-dum)/sigma_a)
    trans_a(2,3)=D_ANORDF((a(3)-rho_a*a(2)+dum)/sigma_a)-D_ANORDF((a(3)-rho_a*a(2)-dum)/sigma_a)
    trans_a(3,3)=D_ANORDF((a(3)-rho_a*a(3)+dum)/sigma_a)-D_ANORDF((a(3)-rho_a*a(3)-dum)/sigma_a)
    trans_a(4,3)=D_ANORDF((a(3)-rho_a*a(4)+dum)/sigma_a)-D_ANORDF((a(3)-rho_a*a(4)-dum)/sigma_a)
    trans_a(5,3)=D_ANORDF((a(3)-rho_a*a(5)+dum)/sigma_a)-D_ANORDF((a(3)-rho_a*a(5)-dum)/sigma_a)
    trans_a(1,4)=D_ANORDF((a(4)-rho_a*a(1)+dum)/sigma_a)-D_ANORDF((a(4)-rho_a*a(1)-dum)/sigma_a)
    trans_a(2,4)=D_ANORDF((a(4)-rho_a*a(2)+dum)/sigma_a)-D_ANORDF((a(4)-rho_a*a(2)-dum)/sigma_a)
    trans_a(3,4)=D_ANORDF((a(4)-rho_a*a(3)+dum)/sigma_a)-D_ANORDF((a(4)-rho_a*a(3)-dum)/sigma_a)
    trans_a(4,4)=D_ANORDF((a(4)-rho_a*a(4)+dum)/sigma_a)-D_ANORDF((a(4)-rho_a*a(4)-dum)/sigma_a)
    trans_a(5,4)=D_ANORDF((a(4)-rho_a*a(5)+dum)/sigma_a)-D_ANORDF((a(4)-rho_a*a(5)-dum)/sigma_a)
    trans_a(1,5)=1D0-D_ANORDF((a(5)-rho_a*a(1)-dum)/sigma_a)
    trans_a(2,5)=1D0-D_ANORDF((a(5)-rho_a*a(2)-dum)/sigma_a)
    trans_a(3,5)=1D0-D_ANORDF((a(5)-rho_a*a(3)-dum)/sigma_a)
    trans_a(4,5)=1D0-D_ANORDF((a(5)-rho_a*a(4)-dum)/sigma_a)
    trans_a(5,5)=1D0-D_ANORDF((a(5)-rho_a*a(5)-dum)/sigma_a)

    prob_a=1D0/5D0
    
    do it=1,100
        prob_a(:)=MATMUL(prob_a(:),trans_a(:,:))
    end do

    !Print *,prob_u(:)
    !
    !Print *,trans_u(1,:)
    !Print *,trans_u(2,:)
    !Print *,trans_u(3,:)
    !Print *,trans_u(4,:)
    !Print *,trans_u(5,:)
    !
    !dum=0D0
    !do it=1,5
    !    dum=dum+trans_u(3,it)
    !end do
    
    !Print *,dum
    
    !Print *,prob_a(:)
    
    !STOP
    
    call random_number(random1)
    
    call random_number(random2)
    
    call random_number(random3)
    
!    open(1, file='random1.txt')
!    
!        read (1, *) random1
!        
!    close(1)
!    
!    open(2, file='random2.txt')
!    
!        read (2, *) random2
!        
!    close(2)
!    
!    open(3, file='random3.txt')
!    
!        read (3, *) random3
!        
!    close(3)
    
            
        end subroutine Initialize  
             
        subroutine update_thetas(tlevel, tprog)
            real(8) :: tlevel, tprog

            theta(:) = (/ 0.88787*tax_level_scale, 0.13719*tax_prog_scale /)
        end subroutine update_thetas
    
    end program Laffer
