subroutine Solvelastactive(ik)

    !This subroutine computes optimal policies at age 64
    use Model_Parameters
    use PolicyFunctions
    use glob0
    use Utilities
    !USE LCONF_INT
    !USE CSVAL_INT
    !USE NEQNF_INT
    !USE NEQBF_INT
    !USE ERSET_INT

    implicit none

    integer, INTENT(IN) :: ik
    integer :: ix,ixd,iam,ium,iaf,iuf,iu2,iu3,j,ifc
    real(8), dimension (:,:,:,:,:,:,:), allocatable :: ce,cu,ke,ku,nem,nef,num,nuf,ve,vu
    real(8), dimension (:,:,:,:,:,:), allocatable :: ces,cus,kes,kus,nes,nus,ves,vus
    real(8), dimension (:), allocatable :: Expdum
    real(8), dimension (:,:,:), allocatable :: labormdum, laborfdum
    real(8), dimension (:,:), allocatable :: labor1workdum
    integer :: NEQ=0, IERSVR=0, IPACT=0, ISACT=0
    real(8) :: c2, MU2, d1, d2, vp(nu),dum3,dum4,dum5,dum6,y
    real(8) :: ACC=0.0001d0,ERREL=0.0001d0
    real(8) :: P1,P2,P3,P4,V2,V3,dum2,pnt2(3),pnt1(2)

    real(8) :: vnext


    allocate(ce(nk,T,na,nu,na,nu,nfc))
    allocate(cu(nk,T,na,nu,na,nu,nfc))
    allocate(ke(nk,T,na,nu,na,nu,nfc))
    allocate(ku(nk,T,na,nu,na,nu,nfc))
    allocate(nem(nk,T,na,nu,na,nu,nfc))
    allocate(nef(nk,T,na,nu,na,nu,nfc))
    allocate(num(nk,T,na,nu,na,nu,nfc))
    allocate(nuf(nk,T,na,nu,na,nu,nfc))
    allocate(ve(nk,T,na,nu,na,nu,nfc))
    allocate(vu(nk,T,na,nu,na,nu,nfc))
    allocate(labormdum(nc,nw,nw))
    allocate(laborfdum(nc,nw,nw))
    allocate(labor1workdum(nc,nw))

    ce=0d0
    cu=0d0
    ke=0d0
    ku=0d0
    nem=0d0
    nef=0d0
    num=0d0
    nuf=0d0
    ve=0d0
    vu=0d0

    allocate(ces(2,nk,T,na,nu,nfc))
    allocate(cus(2,nk,T,na,nu,nfc))
    allocate(kes(2,nk,T,na,nu,nfc))
    allocate(kus(2,nk,T,na,nu,nfc))
    allocate(nes(2,nk,T,na,nu,nfc))
    allocate(nus(2,nk,T,na,nu,nfc))
    allocate(ves(2,nk,T,na,nu,nfc))
    allocate(vus(2,nk,T,na,nu,nfc))

    ces=0d0
    cus=0d0
    kes=0d0
    kus=0d0
    nes=0d0
    nus=0d0
    ves=0d0
    vus=0d0

    allocate(Expdum(12))

    do it=1,12
        Expdum(it)=1*1d0+(it-1d0)*4d0
    end do

    ! Last period of active life
    !if employed

        labormdum=laborm(:,:,:)
        laborfdum=laborf(:,:,:)
        do ifc=1,nfc
        do iam = 1, na
            do ium = 1, nu
                    do iaf = 1, na
                        do iuf = 1, nu
                            !do ixd = 1, 12
                                !Print *,'ix is',ix
                                !Finding optimal capital by golden search
                                ix=T
                                wagem = wage(1,a(1,iam),dble(T),u(1,ium))/(1d0+t_employer)
                                wagef = wage(2,a(2,iaf),dble(ix),u(2,iuf))/(1d0+t_employer)
                                P1=0.01d0
                                P4=min((k_grid(nk)-0.001d0)/(1d0+tc),((k_grid(ik) + Gamma_redistr)*(1d0+r*(1d0-tk))+lumpsum+(wagem+wagef)*(1d0-tax_labor(wagem+wagef)-tSS_employee(wagem+wagef)))/(1d0+tc))
                                do
                                    P2 = P1 + ((3.0-sqrt(5.0))/2.0)*(P4-P1)
                                    P3 = P1 + ((sqrt(5.0)-1.0)/2.0)*(P4-P1)
                                    
                                    pnt2 = (/P2, wagem, wagef/)
                                    dum4 = min(max(trilin_interp(c_grid, wage_grid, wage_grid, labormdum, nc, nw, nw, pnt2),1d-10),1d0)
                                    dum5 = min(max(trilin_interp(c_grid, wage_grid, wage_grid, laborfdum, nc, nw, nw, pnt2),1d-10),1d0)
                                    y=dum4*wagem+dum5*wagef
                                    dum2=((k_grid(ik) + Gamma_redistr)*(1d0+r*(1d0-tk))+lumpsum+y*(1d0-tax_labor(y)-tSS_employee(y))-P2*(1d0+tc))/(1d0+mu)
                                    if(dum2<0d0) then
                                        V2=-999999999d0
                                    else
                                        V2=Uc(P2)+Ul(dum4,dum5)-fc(1,ifc)
                                        vnext = ppp_csval(dum2, k_grid, nk, ev_spln_coefs_ret(:,:,1))
                                        !V2=V2+beta*OmegaActive(T)*D_CSVAL(dum2,BREAK,ev_spln_coefs_ret(:,:,1))
                                        V2=V2+beta*OmegaActive(T)*vnext
                                    end if
                                    
                                    pnt2 = (/P3, wagem, wagef/)
                                    dum4 = min(max(trilin_interp(c_grid, wage_grid, wage_grid, labormdum, nc, nw, nw, pnt2),1d-10),1d0)
                                    dum5 = min(max(trilin_interp(c_grid, wage_grid, wage_grid, laborfdum, nc, nw, nw, pnt2),1d-10),1d0)
                                    y=dum4*wagem+dum5*wagef
                                    dum2=((k_grid(ik) + Gamma_redistr)*(1d0+r*(1d0-tk))+lumpsum+y*(1d0-tax_labor(y)-tSS_employee(y))-P3*(1d0+tc))/(1d0+mu)
                                    if(dum2<0d0) then
                                        V3=-999999999d0
                                    else
                                        V3=Uc(P3)+Ul(dum4,dum5)-fc(1,ifc)
                                        vnext = ppp_csval(dum2, k_grid, nk, ev_spln_coefs_ret(:,:,1))
                                        !V3=V3+beta*OmegaActive(T)*D_CSVAL(dum2,BREAK,ev_spln_coefs_ret(:,:,1))
                                        V3=V3+beta*OmegaActive(T)*vnext
                                    end if
                                    
                                    if (V2 < V3) then
                                        P1=P2
                                    else
                                        P4=P3
                                    end if
                                    if((P4-P1)<1d-4) exit
                                end do
                                
                                Ve(ik,ix,iam,ium,iaf,iuf,ifc)=V2
                                ke(ik,ix,iam,ium,iaf,iuf,ifc)=dum2
                                nem(ik,ix,iam,ium,iaf,iuf,ifc)=dum4
                                nef(ik,ix,iam,ium,iaf,iuf,ifc)=dum5
                                ce(ik,ix,iam,ium,iaf,iuf,ifc)=P2
                                
                                if(nem(ik,ix,iam,ium,iaf,iuf,ifc)<0d0) then
                                    Print *,'ik is',ik
                                    Print *,'ix is',ix
                                    Print *,'iam is',iam
                                    Print *,'ium is',ium
                                    Print *,'iaf is',iaf
                                    Print *,'iuf is',iuf
                                    Print *,'num(ik,ix,iam,ium,iaf,iuf,ifc) is',num(ik,ix,iam,ium,iaf,iuf,ifc)
                                    Print *,'nuf(ik,ix,iam,ium,iaf,iuf,ifc) is',nuf(ik,ix,iam,ium,iaf,iuf,ifc)
                                    pause
                                end if
                                
                                if(nef(ik,ix,iam,ium,iaf,iuf,ifc)<0d0) then
                                    Print *,'ik is',ik
                                    Print *,'ix is',ix
                                    Print *,'iam is',iam
                                    Print *,'ium is',ium
                                    Print *,'iaf is',iaf
                                    Print *,'iuf is',iuf
                                    Print *,'nem(ik,ix,iam,ium,iaf,iuf,ifc) is',nem(ik,ix,iam,ium,iaf,iuf,ifc)
                                    Print *,'nef(ik,ix,iam,ium,iaf,iuf,ifc) is',nef(ik,ix,iam,ium,iaf,iuf,ifc)
                                    pause
                                end if
                                
                        !end do
                    end do
                end do
            end do
        end do
        end do

    !If female unemployed

        labor1workdum=labor1work(:,:)
        do ifc=1,nfc
        do iam = 1, na
            do ium = 1, nu
                do iaf = 1, na
                    do iuf = 1, nu
                        !do ixd = 1, 12
                            !Print *,'ix is',ix
                            !Finding optimal capital by golden search
                            ix=T
                            wagem = wage(1,a(1,iam),dble(T),u(1,ium))/(1d0+t_employer)
                            P1=0.01d0
                            P4=min((k_grid(nk)-0.001d0)/(1d0+tc),((k_grid(ik) + Gamma_redistr)*(1d0+r*(1d0-tk))+lumpsum+Unemp_benefit+(wagem)*(1d0-tax_labor(wagem)-tSS_employee(wagem)))/(1d0+tc))
                            do
                                P2 = P1 + ((3.0-sqrt(5.0))/2.0)*(P4-P1)
                                P3 = P1 + ((sqrt(5.0)-1.0)/2.0)*(P4-P1)
                                
                                pnt1 = (/P2, wagem/)
                                dum4 = min(max(bilin_interp(c_grid, wage_grid, labor1workdum, nc, nw, pnt1),0d0),1d0)
                                y=dum4*wagem
                                dum2=((k_grid(ik) + Gamma_redistr)*(1d0+r*(1d0-tk))+lumpsum+Unemp_benefit+y*(1d0-tax_labor(y)-tSS_employee(y))-P2*(1d0+tc))/(1d0+mu)
                                if(dum2<0d0) then
                                    V2=-999999999d0
                                else
                                    V2=Uc(P2)+Ul(dum4,0d0)
                                    vnext = ppp_csval(dum2, k_grid, nk, ev_spln_coefs_ret(:,:,1))
                                    !V2=V2+beta*OmegaActive(T)*D_CSVAL(dum2,BREAK,ev_spln_coefs_ret(:,:,1))
                                    V2=V2+beta*OmegaActive(T)*vnext
                                end if
                                
                                pnt1 = (/P3, wagem/)
                                dum4 = min(max(bilin_interp(c_grid, wage_grid, labor1workdum, nc, nw, pnt1),0d0),1d0)
                                y=dum4*wagem
                                dum2=((k_grid(ik) + Gamma_redistr)*(1d0+r*(1d0-tk))+lumpsum+Unemp_benefit+y*(1d0-tax_labor(y)-tSS_employee(y))-P3*(1d0+tc))/(1d0+mu)
                                if(dum2<0d0) then
                                    V3=-999999999d0
                                else
                                    V3=Uc(P3)+Ul(dum4,0d0)
                                    vnext = ppp_csval(dum2, k_grid, nk, ev_spln_coefs_ret(:,:,1))
                                    !V3=V3+beta*OmegaActive(T)*D_CSVAL(dum2,BREAK,ev_spln_coefs_ret(:,:,1))
                                    V3=V3+beta*OmegaActive(T)*vnext
                                end if
                                
                                if (V2 < V3) then
                                    P1=P2
                                else
                                    P4=P3
                                end if
                                if((P4-P1)<1d-4) exit
                            end do
                            
                            Vu(ik,ix,iam,ium,iaf,iuf,ifc)=V2
                            ku(ik,ix,iam,ium,iaf,iuf,ifc)=dum2
                            num(ik,ix,iam,ium,iaf,iuf,ifc)=dum4
                            nuf(ik,ix,iam,ium,iaf,iuf,ifc)=0d0
                            cu(ik,ix,iam,ium,iaf,iuf,ifc)=P2
                            
                            if(num(ik,ix,iam,ium,iaf,iuf,ifc)<0d0) then
                                Print *,'ik is',ik
                                Print *,'ix is',ix
                                Print *,'iam is',iam
                                Print *,'ium is',ium
                                Print *,'iaf is',iaf
                                Print *,'iuf is',iuf
                                Print *,'num(ik,ix,iam,ium,iaf,iuf,ifc) is',num(ik,ix,iam,ium,iaf,iuf,ifc)
                                Print *,'nuf(ik,ix,iam,ium,iaf,iuf,ifc) is',nuf(ik,ix,iam,ium,iaf,iuf,ifc)
                                pause
                            end if
                            
                            if(nuf(ik,ix,iam,ium,iaf,iuf,ifc)<0d0) then
                                Print *,'ik is',ik
                                Print *,'ix is',ix
                                Print *,'iam is',iam
                                Print *,'ium is',ium
                                Print *,'iaf is',iaf
                                Print *,'iuf is',iuf
                                Print *,'num(ik,ix,iam,ium,iaf,iuf,ifc) is',num(ik,ix,iam,ium,iaf,iuf,ifc)
                                Print *,'nuf(ik,ix,iam,ium,iaf,iuf,ifc) is',nuf(ik,ix,iam,ium,iaf,iuf,ifc)
                                pause
                            end if
                            
                    !end do
                end do
            end do
            end do
        end do
        end do
    
    !Vu=-999999999d0
    
    do ifc=1,nfc
    do ium = 1, nu
        do ix = 1, T
            do iam = 1, na
                do iuf = 1, nu
                    do iaf = 1, na
                        if (ve(ik,ix,iam,ium,iaf,iuf,ifc) >= vu(ik,ix,iam,ium,iaf,iuf,ifc)) then
                            v(ik,ix,iam,ium,iaf,iuf,T,ifc)=ve(ik,ix,iam,ium,iaf,iuf,ifc)
                            c(ik,ix,iam,ium,iaf,iuf,T,ifc)=ce(ik,ix,iam,ium,iaf,iuf,ifc)
                            k(ik,ix,iam,ium,iaf,iuf,T,ifc)=ke(ik,ix,iam,ium,iaf,iuf,ifc)
                            nm(ik,ix,iam,ium,iaf,iuf,T,ifc)=nem(ik,ix,iam,ium,iaf,iuf,ifc)
                            nf(ik,ix,iam,ium,iaf,iuf,T,ifc)=nef(ik,ix,iam,ium,iaf,iuf,ifc)
                        else
                            v(ik,ix,iam,ium,iaf,iuf,T,ifc)=vu(ik,ix,iam,ium,iaf,iuf,ifc)
                            c(ik,ix,iam,ium,iaf,iuf,T,ifc)=cu(ik,ix,iam,ium,iaf,iuf,ifc)
                            k(ik,ix,iam,ium,iaf,iuf,T,ifc)=ku(ik,ix,iam,ium,iaf,iuf,ifc)
                            nm(ik,ix,iam,ium,iaf,iuf,T,ifc)=num(ik,ix,iam,ium,iaf,iuf,ifc)
                            nf(ik,ix,iam,ium,iaf,iuf,T,ifc)=nuf(ik,ix,iam,ium,iaf,iuf,ifc)
                        end if
                    end do
                end do
            end do
        end do
    end do
    end do

    !do ifc=1,nfc
    !do ium = 1, nu
    !    do ixd = 1, 12
    !        do iam = 1, na
    !            do iuf = 1, nu
    !                do iaf = 1, na
    !                    ix=1+(ixd-1)*4
    !                    vdum(ik,ixd,iam,ium,iaf,iuf,T,ifc)=v(ik,ix,iam,ium,iaf,iuf,T,ifc)
    !                    cdum(ik,ixd,iam,ium,iaf,iuf,T,ifc)=c(ik,ix,iam,ium,iaf,iuf,T,ifc)
    !                    gkdum(ik,ixd,iam,ium,iaf,iuf,T,ifc)=k(ik,ix,iam,ium,iaf,iuf,T,ifc)
    !                    nmdum(ik,ixd,iam,ium,iaf,iuf,T,ifc)=nm(ik,ix,iam,ium,iaf,iuf,T,ifc)
    !                    nfdum(ik,ixd,iam,ium,iaf,iuf,T,ifc)=nf(ik,ix,iam,ium,iaf,iuf,T,ifc)
    !                end do
    !            end do
    !        end do
    !    end do
    !end do
    !end do

    !Print *,'nmdum(1,:,1,1,1,1,T) is',nmdum(1,:,1,1,1,1,T)

    !do ifc=1,nfc
    !do ium = 1, nu
    !    do ix = 1, T
    !        do iam = 1, na
    !            do iuf = 1, nu
    !                do iaf = 1, na
    !                    v(ik,ix,iam,ium,iaf,iuf,T,ifc)=LinInterp(ix*1d0,Expdum,vdum(ik,:,iam,ium,iaf,iuf,T,ifc),12)
    !                    c(ik,ix,iam,ium,iaf,iuf,T,ifc)=LinInterp(ix*1d0,Expdum,cdum(ik,:,iam,ium,iaf,iuf,T,ifc),12)
    !                    k(ik,ix,iam,ium,iaf,iuf,T,ifc)=LinInterp(ix*1d0,Expdum,gkdum(ik,:,iam,ium,iaf,iuf,T,ifc),12)
    !                    nm(ik,ix,iam,ium,iaf,iuf,T,ifc)=LinInterp(ix*1d0,Expdum,nmdum(ik,:,iam,ium,iaf,iuf,T,ifc),12)
    !                    nf(ik,ix,iam,ium,iaf,iuf,T,ifc)=LinInterp(ix*1d0,Expdum,nfdum(ik,:,iam,ium,iaf,iuf,T,ifc),12)
    !                if(nm(ik,ix,iam,ium,iaf,iuf,T,ifc)<0d0) then
    !                print *, 'interpolation'
    !                Print *,'ik is',ik
    !                Print *,'ix is',ix
    !                Print *,'iam is',iam
    !                Print *,'ium is',ium
    !                Print *,'iaf is',iaf
    !                Print *,'iuf is',iuf
    !                Print *,'nm(ik,ix,iam,ium,iaf,iuf,T-it,,ifc) is',nm(ik,ix,iam,ium,iaf,iuf,T,ifc)
    !                Print *,'nf(ik,ix,iam,ium,iaf,iuf,T-it,,ifc) is',nf(ik,ix,iam,ium,iaf,iuf,T,ifc)
    !                Print *,'Expdum is',Expdum
    !                Print *,'nfdum(ik,:,iam,ium,iaf,iuf,T-it,ifc) is',nfdum(ik,:,iam,ium,iaf,iuf,T,ifc)
    !                pause
    !                end if
    !                if(nf(ik,ix,iam,ium,iaf,iuf,T,ifc)<0d0) then
    !                print *, 'interpolation'
    !                Print *,'ik is',ik
    !                Print *,'ix is',ix
    !                Print *,'iam is',iam
    !                Print *,'ium is',ium
    !                Print *,'iaf is',iaf
    !                Print *,'iuf is',iuf
    !                Print *,'nm(ik,ix,iam,ium,iaf,iuf,T-it,ifc) is',nm(ik,ix,iam,ium,iaf,iuf,T,ifc)
    !                Print *,'nf(ik,ix,iam,ium,iaf,iuf,T-it,ifc) is',nf(ik,ix,iam,ium,iaf,iuf,T,ifc)
    !                Print *,'Expdum is',Expdum
    !                Print *,'nfdum(ik,:,iam,ium,iaf,iuf,T-it,ifc) is',nfdum(ik,:,iam,ium,iaf,iuf,T,ifc)
    !                pause
    !                end if
    !                end do
    !            end do
    !        end do
    !    end do
    !end do
    !end do

    !ev(ik,:,:,:,:,:,T,:)=0d0
    !
    !do j=1, nfam
    !do ium = 1, nu
    !    do ix = 1, T
    !        do iam = 1, na
    !            do iuf = 1, nu
    !                do iaf = 1, na
    !                    do iu2=1,nu
    !                        do iu3=1,nu
    !                            ev(ik,ix,iam,ium,iaf,iuf,T,j,ifc)=ev(ik,ix,iam,ium,iaf,iuf,T,j,ifc)+trans_u(1,ium,iu2)*trans_u(2,iuf,iu3)*V(ik,ix,iam,iu2,iaf,iu3,T,j,ifc)
    !                        end do
    !                    end do
    !                end do
    !            end do
    !        end do
    !    end do
    !end do
    !end do

    !Singles    

    j=2

    do ifc=1,nfc
    do iam = 1, na
        do ium = 1, nu
            !do ix = 1, T
            ix=T
                !Print *,'ix is',ix
                !Finding optimal capital by golden search
                wagef = wage(2,a(2,iam),dble(ix),u(2,ium))/(1d0+t_employer)
                P1=0.01d0
                P4=min((k_grid(nk)-0.001d0)/(1d0+tc),((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+wagef*(1d0-tax_labors(wagef)-tSS_employee(wagef)))/(1d0+tc))
                do
                    P2 = P1 + ((3.0-sqrt(5.0))/2.0)*(P4-P1)
                    P3 = P1 + ((sqrt(5.0)-1.0)/2.0)*(P4-P1)

                    pnt1 = (/P2, wagef/)
                    dum4 = min(max(bilin_interp(c_grid, wage_grid, laborsinglef, nc, nw, pnt1),0d0),1d0)
                    y=dum4*wagef
                    dum2=((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+y*(1d0-tax_labors(y)-tSS_employee(y))-P2*(1d0+tc))/(1d0+mu)
                    if(dum2<0d0) then
                        V2=-999999999d0
                    else
                        V2=Uc(P2)-chifs*(dum4**(1d0+etaf))/(1d0+etaf)-fc(2,ifc)
                        vnext = ppp_csval(dum2, k_grid, nk, evs_spln_coefs_ret(:,:,1))
                        !V2=V2+beta*OmegaActive(T)*D_CSVAL(dum2,BREAK,evs_spln_coefs_ret(:,:,1))
                        V2=V2+beta*OmegaActive(T)*vnext
                    end if

                    pnt1 = (/P3, wagef/)
                    dum4 = min(max(bilin_interp(c_grid, wage_grid, laborsinglef, nc, nw, pnt1),0d0),1d0)
                    y=dum4*wagef
                    dum2=((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+y*(1d0-tax_labors(y)-tSS_employee(y))-P3*(1d0+tc))/(1d0+mu)
                    if(dum2<0d0) then
                        V3=-999999999d0
                    else
                        vnext = ppp_csval(dum2, k_grid, nk, evs_spln_coefs_ret(:,:,1))
                        V3=Uc(P3)-chifs*(dum4**(1d0+etaf))/(1d0+etaf)-fc(2,ifc)
                        V3=V3+beta*OmegaActive(T)*vnext
                    end if

                    if (V2 < V3) then
                        P1=P2
                    else
                        P4=P3
                    end if
                    if((P4-P1)<1d-4) exit
                end do

                Ves(j,ik,ix,iam,ium,ifc)=V2
                kes(j,ik,ix,iam,ium,ifc)=dum2
                nes(j,ik,ix,iam,ium,ifc)=dum4
                ces(j,ik,ix,iam,ium,ifc)=P2

                if(nes(j,ik,ix,iam,ium,ifc)<0d0) then
                    Print *,'ik is',ik
                    Print *,'ix is',ix
                    Print *,'iam is',iam
                    Print *,'ium is',ium
                    Print *,'nes(j,ik,ix,iam,ium,ifc) is',nes(j,ik,ix,iam,ium,ifc)
                    pause
                end if
            !end do
        end do
    end do
    end do

    !If single female unemployed

    do ifc=1,nfc
    do iam = 1, na
        do ium = 1, nu
            !do ix = 1, T
            ix=T
                !Print *,'ix is',ix
                !Finding optimal capital by golden search
                P1=0.01d0
                P4=min((k_grid(nk)-0.001d0)/(1d0+tc),((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+Unemp_benefit)/(1d0+tc))
                do
                P2 = P1 + ((3.0-sqrt(5.0))/2.0)*(P4-P1)
                P3 = P1 + ((sqrt(5.0)-1.0)/2.0)*(P4-P1)

                dum2=((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+Unemp_benefit-P2*(1d0+tc))/(1d0+mu)
                if(dum2<0d0) then
                    V2=-999999999d0
                else
                    vnext = ppp_csval(dum2, k_grid, nk, evs_spln_coefs_ret(:,:,1))
                    V2=Uc(P2)
                    !V2=V2+beta*OmegaActive(T)*D_CSVAL(dum2,BREAK,evs_spln_coefs_ret(:,:,1))
                    V2=V2+beta*OmegaActive(T)*vnext
                end if

                dum2=((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+Unemp_benefit-P3*(1d0+tc))/(1d0+mu)
                if(dum2<0d0) then
                    V3=-999999999d0
                else
                    vnext = ppp_csval(dum2, k_grid, nk, evs_spln_coefs_ret(:,:,1))
                    V3=Uc(P3)
                    !V3=V3+beta*OmegaActive(T)*D_CSVAL(dum2,BREAK,evs_spln_coefs_ret(:,:,1))
                    V3=V3+beta*OmegaActive(T)*vnext
                end if

                if (V2 < V3) then
                    P1=P2
                else
                    P4=P3
                end if
                if((P4-P1)<1d-4) exit
                end do

                Vus(j,ik,ix,iam,ium,ifc)=V2
                kus(j,ik,ix,iam,ium,ifc)=dum2
                nus(j,ik,ix,iam,ium,ifc)=0d0
                cus(j,ik,ix,iam,ium,ifc)=P2

            !end do
        end do
    end do
    end do

    !Vus=-999999999d0
    do ifc=1,nfc
    do ium = 1, nu
        do ix = 1, T
            do iam = 1, na
                if (ves(j,ik,ix,iam,ium,ifc) >= vus(j,ik,ix,iam,ium,ifc)) then
                    vs(j,ik,ix,iam,ium,T,ifc)=ves(j,ik,ix,iam,ium,ifc)
                    cs(j,ik,ix,iam,ium,T,ifc)=ces(j,ik,ix,iam,ium,ifc)
                    ks(j,ik,ix,iam,ium,T,ifc)=kes(j,ik,ix,iam,ium,ifc)
                    ns(j,ik,ix,iam,ium,T,ifc)=nes(j,ik,ix,iam,ium,ifc)
                else
                    vs(j,ik,ix,iam,ium,T,ifc)=vus(j,ik,ix,iam,ium,ifc)
                    cs(j,ik,ix,iam,ium,T,ifc)=cus(j,ik,ix,iam,ium,ifc)
                    ks(j,ik,ix,iam,ium,T,ifc)=kus(j,ik,ix,iam,ium,ifc)
                    ns(j,ik,ix,iam,ium,T,ifc)=nus(j,ik,ix,iam,ium,ifc)
                end if
            end do
        end do
    end do
    end do


    !do ium = 1, nu
    !    do ixd = 1, 12
    !        do iam = 1, na
    !                    ix=1+(ixd-1)*4
    !                    vsdum(j,ik,ixd,iam,ium,T,ifc)=vs(j,ik,ix,iam,ium,T,ifc)
    !                    csdum(j,ik,ixd,iam,ium,T,ifc)=cs(j,ik,ix,iam,ium,T,ifc)
    !                    gksdum(j,ik,ixd,iam,ium,T,ifc)=ks(j,ik,ix,iam,ium,T,ifc)
    !                    nsdum(j,ik,ixd,iam,ium,T,ifc)=ns(j,ik,ix,iam,ium,T,ifc)
    !        end do
    !    end do
    !end do
    !
    !!Print *,'nmdum(1,:,1,1,1,1,T) is',nmdum(1,:,1,1,1,1,T)
    !
    !do ium = 1, nu
    !    do ix = 1, T
    !        do iam = 1, na
    !                    vs(j,ik,ix,iam,ium,T,ifc)=LinInterp(ix*1d0,Expdum,vsdum(j,ik,:,iam,ium,T,ifc),12)
    !                    cs(j,ik,ix,iam,ium,T,ifc)=LinInterp(ix*1d0,Expdum,csdum(j,ik,:,iam,ium,T,ifc),12)
    !                    ks(j,ik,ix,iam,ium,T,ifc)=LinInterp(ix*1d0,Expdum,gksdum(j,ik,:,iam,ium,T,ifc),12)
    !                    ns(j,ik,ix,iam,ium,T,ifc)=LinInterp(ix*1d0,Expdum,nsdum(j,ik,:,iam,ium,T,ifc),12)
    !                if(ns(j,ik,ix,iam,ium,T,ifc)<0d0) then
    !                print *, 'interpolation'
    !                Print *,'ik is',ik
    !                Print *,'ix is',ix
    !                Print *,'iam is',iam
    !                Print *,'ium is',ium
    !                Print *,'iaf is',iaf
    !                Print *,'iuf is',iuf
    !                Print *,'ns(j,ik,ix,iam,ium,T,ifc) is',ns(j,ik,ix,iam,ium,T,ifc)
    !                Print *,'Expdum is',Expdum
    !                Print *,'nsdum(j,ik,ixd,iam,ium,T,ifc) is',nsdum(j,ik,ixd,iam,ium,T,ifc)
    !                pause
    !                end if
    !        end do
    !    end do
    !end do

    !Men   
    j=1

    do iam = 1, na
        do ium = 1, nu
            !Print *,'ix is',ix
            !Finding optimal capital by golden search
            wagem = wage(1,a(1,iam),dble(T),u(1,ium))/(1d0+t_employer)
            P1=0.01d0
            P4=min((k_grid(nk)-0.001d0)/(1d0+tc),((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+wagem*(1d0-tax_labors(wagem)-tSS_employee(wagem)))/(1d0+tc))
            do
                P2 = P1 + ((3.0-sqrt(5.0))/2.0)*(P4-P1)
                P3 = P1 + ((sqrt(5.0)-1.0)/2.0)*(P4-P1)
                
                pnt1 = (/P2, wagem/)
                dum4 = min(max(bilin_interp(c_grid, wage_grid, laborsinglem, nc, nw, pnt1),0d0),1d0)
                y=dum4*wagem
                dum2=((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+y*(1d0-tax_labors(y)-tSS_employee(y))-P2*(1d0+tc))/(1d0+mu)
                if(dum2<0d0) then
                    V2=-999999999d0
                else
                    vnext = ppp_csval(dum2, k_grid, nk, evs_spln_coefs_ret(:,:,1))
                    V2=Uc(P2)-chims*(dum4**(1d0+etam))/(1d0+etam)
                    !V2=V2+beta*OmegaActive(T)*D_CSVAL(dum2,BREAK,evs_spln_coefs_ret(:,:,1))
                    V2=V2+beta*OmegaActive(T)*vnext
                end if
                
                pnt1 = (/P3, wagem/)
                dum4 = min(max(bilin_interp(c_grid, wage_grid, laborsinglem, nc, nw, pnt1),0d0),1d0)
                y=dum4*wagem
                dum2=((k_grid(ik) + Gamma_redistr*0.5d0)*(1d0+r*(1d0-tk))+lumpsum*0.5d0+y*(1d0-tax_labors(y)-tSS_employee(y))-P3*(1d0+tc))/(1d0+mu)
                if(dum2<0d0) then
                    V3=-999999999d0
                else
                    vnext = ppp_csval(dum2, k_grid, nk, evs_spln_coefs_ret(:,:,1))
                    V3=Uc(P3)-chims*(dum4**(1d0+etam))/(1d0+etam)
                    !V3=V3+beta*OmegaActive(T)*D_CSVAL(dum2,BREAK,evs_spln_coefs_ret(:,:,1))
                    V3=V3+beta*OmegaActive(T)*vnext
                end if
                
                if (V2 < V3) then
                    P1=P2
                else
                    P4=P3
                end if
                if((P4-P1)<1d-4) exit
            end do
            
            Vs(j,ik,:,iam,ium,T,:)=V2
            ks(j,ik,:,iam,ium,T,:)=dum2
            ns(j,ik,:,iam,ium,T,:)=dum4
            cs(j,ik,:,iam,ium,T,:)=P2
                
            if(ns(j,ik,1,iam,ium,T,1)<0d0) then
                Print *,'ik is',ik
                Print *,'ix is',ix
                Print *,'iam is',iam
                Print *,'ium is',ium
                Print *,'ns(j,ik,1,iam,ium,T,1) is',ns(j,ik,1,iam,ium,T,1)
                pause
            end if
        end do
    end do


    evs(:,ik,:,:,:,T,:)=0d0

    j=2
    
    do ium = 1, nu
        do ifc=1,nfc
            do ix = 1, T
                do iam = 1, na
                    do iu2=1,nu
                        evs(j,ik,ix,iam,ium,T,ifc)=evs(j,ik,ix,iam,ium,T,ifc)+trans_u(2,ium,iu2)*Vs(j,ik,ix,iam,iu2,T,ifc)
                    end do
                end do
            end do
        end do
    end do

    j=1
    do ium = 1, nu
        do iam = 1, na
            do iu2=1,nu    
                evs(j,ik,:,iam,ium,T,:)=evs(j,ik,:,iam,ium,T,:)+trans_u(1,ium,iu2)*Vs(j,ik,1,iam,iu2,T,1)
            end do
        end do
    end do

            
end subroutine Solvelastactive
